package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBmap;
import cmdbuild.utils.AllChildren;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class CreateRelationForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String className;
	private int class1id; //
	private int obj1id;   //
	private int class2id;  //
	private int obj2id;   //
	private String method;
	private String search; 
	private String domain;
	private String domainToSearch;
	private String oggetto; 
	private Collection classCollection;
	private Collection domainNameCollection;
	private boolean relationFull; 
	private Hashtable cardin;
	private String cardinArray;

	public CreateRelationForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		
		System.out.println("**CREATERELATION RESET**");
		if (request.getParameter("class1id") != null){
			class1id = Integer.parseInt(request.getParameter("class1id"));
		} 
		if (request.getParameter("obj1id") != null){
			obj1id = Integer.parseInt(request.getParameter("obj1id"));
		} 
		if (request.getSession().getAttribute("cardinHashTable")!=null){
			cardin = (Hashtable)request.getSession().getAttribute("cardinHashTable");
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
		ClassBean cb = null;
		try {
    		cb = CMDB.selectClassById(class1id);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		className = cb.getName();
		request.getSession().setAttribute("class",className);
		
		System.out.println("className="+className);
		System.out.println("CRF class1id="+class1id+" obj1id="+obj1id);

        // creating a tree of this class       
        Hashtable childToParent = new Hashtable();  // key = child   value = parent
        HashSet superSet = new HashSet();    // this set contains only superclasses
        Vector superv = null;
        try {
			superv = CMDB.selectClassTree();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
        Enumeration en = superv.elements();
        InheritsBean inh = null;
		while (en.hasMoreElements()){
			inh = (InheritsBean)en.nextElement();
			childToParent.put(inh.getChild(),inh.getParent());
			if (!superSet.contains(inh.getParent())){
				superSet.add(inh.getParent());
			}
		}
		String targ = className;
		HashSet ptset1 = new HashSet();
		while (childToParent.containsKey(targ)){
			ptset1.add(targ);
			targ = (String)childToParent.get(targ);
		}
		
		CMDBmap MAP = new CMDBmap(db);
		Vector allDomainVector = null;
		// domainVector contains domains of this class (inheritated too)
		Vector domainVector = new Vector();
		try {
			allDomainVector = MAP.selectAllDomain();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		en = allDomainVector.elements();
		DomainBean dm = null;
		while(en.hasMoreElements()){
			dm = (DomainBean)en.nextElement();
			if (ptset1.contains(dm.getStartClass()) || ptset1.contains(dm.getEndClass())){
				domainVector.add(dm);
			}
		}
		// classes in relation with this class
		en = domainVector.elements();
		dm = null;
		Hashtable classi = new Hashtable();
		cb = null;
		while (en.hasMoreElements()){
			dm = (DomainBean)en.nextElement();
			if ( ptset1.contains(dm.getStartClass()) ){ // adding the other
				if (!classi.containsKey(dm.getEndClass())){
					cb = new ClassBean();
					cb.setName(dm.getEndClass());
					System.out.println("Adding "+cb.getName());
					classi.put(cb.getName(),cb);
				}
			} else if ( ptset1.contains(dm.getEndClass()) ) { // dm.getEndClass().equals(className)
				if (!classi.containsKey(dm.getStartClass())){
					cb = new ClassBean();
					cb.setName(dm.getStartClass());
					System.out.println("Adding "+cb.getName());
					classi.put(cb.getName(),cb);
				}
			}
		}
		classCollection = classi.values();
		LinkedList cleanCollection = new LinkedList();
		Iterator ite = classCollection.iterator();
		while (ite.hasNext()){
			cb = (ClassBean)ite.next();
			cleanCollection.add(cb);
		}
		// replacing a superclass width her children
		//Iterator ite = classCollection.iterator();
		AllChildren alc = new AllChildren(superv,superSet);
		LinkedList col1 = null;
		ClassBean cb2 = null;
		while (alc.hasSuperClass(cleanCollection)!=null){
			cb = alc.hasSuperClass(cleanCollection);
			col1 = alc.getChildrenOf(cb.getName());
			Iterator its = col1.iterator();
			while (its.hasNext()){
				cb2 = (ClassBean)its.next();
				cleanCollection.add(cb2);
			}
			//cleanCollection.addAll(col1);
			System.out.println("replacing "+cb.getName()+" with childs");
			cleanCollection.remove(cb);
		}
		classCollection = cleanCollection;
		
		if (request.getParameter("search")!=null){
			domainToSearch = request.getParameter("search");
		} else if (classCollection.size()>0){
			ClassBean cb0 = (ClassBean)classCollection.toArray()[0];
			domainToSearch = cb0.getName(); 
		} else {
			domainToSearch = "";
		}
		System.out.println("searching for "+domainToSearch);
		targ = domainToSearch;
		HashSet ptset2 = new HashSet();
		while (childToParent.containsKey(targ)){
			ptset2.add(targ);
			targ = (String)childToParent.get(targ);
		}
		
		Iterator iter = domainVector.iterator(); // o domainVector???
		Hashtable ht = new Hashtable();
		while (iter.hasNext()){
			dm = (DomainBean)iter.next();
			System.out.println("dm start="+dm.getStartClass()+" dm end="+dm.getEndClass());
			if ( ptset1.contains(dm.getStartClass()) && ptset2.contains(dm.getEndClass()) ){
				cb = new ClassBean();
				cb.setName(dm.getDirectDescription());
				cb.setDescription(dm.getName()+"-"+dm.getDirectDescription());
				if (!ht.containsKey(cb.getName())){
					ht.put(cb.getName(),cb);
				}
				/*
				// if domain goes from asset to asset add the other description to
				if (c1.getSuperClass().equals(dm.getStartClass()) && c2.getSuperClass().equals(dm.getEndClass())){
					cb = new ClassBean();
					cb.setName(dm.getInverseDescription());
					cb.setDescription(dm.getName()+"-"+dm.getInverseDescription());
					if (!c1.getName().equals(c1.getSuperClass()) && !c2.getName().equals(c2.getSuperClass())){
						if (!ht.containsKey(cb.getName())){
							ht.put(cb.getName(),cb);
						}
					}
				}
				*/
			} else if ( ptset2.contains(dm.getStartClass()) && ptset1.contains(dm.getEndClass()) ){
				cb = new ClassBean();
				cb.setName(dm.getInverseDescription());
				cb.setDescription(dm.getName()+"-"+dm.getInverseDescription());
				if (!ht.containsKey(cb.getName())){
					ht.put(cb.getName(),cb);
				}
				/*
				// if domain goes from asset to asset add the other description to
				if (c2.getSuperClass().equals(dm.getStartClass()) && c1.getSuperClass().equals(dm.getEndClass())){
					cb = new ClassBean();
					cb.setName(dm.getDirectDescription());
					cb.setDescription(dm.getName()+"-"+dm.getDirectDescription());
					if (!c1.getName().equals(c1.getSuperClass()) && !c2.getName().equals(c2.getSuperClass())){
						if (!ht.containsKey(cb.getName())){
							ht.put(cb.getName(),cb);
						}
					}
				}
				*/
			} // end if
		} // end while
		domainNameCollection = new LinkedList();
		domainNameCollection = ht.values();
		
		// creating HTML cardinArray
		String domainANDdesc = "";
		String domN;
		String domD;
		String count;
		String cardinality;
		cardinArray = "";
		int i = 0;
		Iterator itc = domainNameCollection.iterator();
		ite = null;
		while (itc.hasNext()){
			domainANDdesc = ((ClassBean)itc.next()).getDescription();
			domN = domainANDdesc.substring(0,domainANDdesc.indexOf("-"));
			domD = domainANDdesc.substring(domainANDdesc.indexOf("-")+1,domainANDdesc.length());
			System.out.println("domN"+domN+" domD"+domD);
			String maxCount = "";
			// getting domain cardinality
			ite = domainVector.iterator();
			DomainBean dm2 = null;
			while (ite.hasNext()){
				dm2 = (DomainBean)ite.next();
				if (dm2.getName().equals(domN)){
					cardinality = dm2.getCardinality();
					if (dm2.getInverseDescription().equals(domD)){ // take the other
						maxCount = cardinality.substring(0,1);
					} else if (dm2.getDirectDescription().equals(domD)){
						maxCount = cardinality.substring(2,3);
					}
					break;
				}
			}
			if (cardin.containsKey("Map_"+domN)){
				count = (String)cardin.get("Map_"+domN);
				System.out.println("count="+count+" maxCount"+maxCount);
				if (count.equals("1") && maxCount.equals("1")){ // you can't add a new relation
					relationFull = true;
				} else {
					relationFull = false;
				}
			}
			if (cardinArray.equals("")){
				cardinArray = "<script type=\"text/javascript\">";
				cardinArray += "var cardin = new Array("+domainNameCollection.size()+");";
				cardinArray += "cardin["+i+"] = "+relationFull+";";
			} else {
				cardinArray += "cardin["+i+"] = "+relationFull+";";
			}
			i++;
		}
		if (!cardinArray.equals("")){
			cardinArray += "</script>";
		} else {
			cardinArray = "<script type=\"text/javascript\">";
			cardinArray += "var cardin = new Array();";
			cardinArray += "</script>";
		}	
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		if ( oggetto == null || oggetto.trim().equals("")){
		}
		CreateRelationForm form = (CreateRelationForm)arg1.getAttribute("createRelationForm"); 
		DomainBean domain = null;
		class2id = form.getClass2id();
		obj2id = form.getObj2id();
		String domainANDdesc = form.getDomain();
		String domN = domainANDdesc.substring(0,domainANDdesc.indexOf("-"));
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBmap MAP = new CMDBmap(db);
		try {
			 domain = MAP.selectDomainByName(domN);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// find if the object selected was already associated (in this domain) with an other Asset
		Vector relationVector = null;
		if (domain.getCardinality()!=null && domain.getCardinality().indexOf("1")!=-1){
			try {
				relationVector = MAP.selectRelations(class2id,obj2id,0,0);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Enumeration en = relationVector.elements();
			RelationBean rb = null;
			while (en.hasMoreElements()){
				rb = (RelationBean)en.nextElement();
				if (rb.getDomainId()==domain.getId()){
					errors.add("oggetto", new ActionMessage("relation.alreadylinked"));
					break;
				}
			}
		}
		return errors;
	}

	public int getClass1id() {
		return class1id;
	}
	public void setClass1id(int class1id) {
		this.class1id = class1id;
	}
	public int getClass2id() {
		return class2id;
	}
	public void setClass2id(int class2id) {
		this.class2id = class2id;
	}
	public int getObj1id() {
		return obj1id;
	}
	public void setObj1id(int obj1id) {
		this.obj1id = obj1id;
	}
	public int getObj2id() {
		return obj2id;
	}
	public void setObj2id(int obj2id) {
		this.obj2id = obj2id;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public String getDomain() {
		return domain;
	}
	public void setDomain(String domain) {
		this.domain = domain;
	}
	public Collection getDomainNameCollection() {
		return domainNameCollection;
	}
	public void setDomainNameCollection(Collection domainNameCollection) {
		this.domainNameCollection = domainNameCollection;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getOggetto() {
		return oggetto;
	}
	public void setOggetto(String oggetto) {
		this.oggetto = oggetto;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public String getDomainToSearch() {
		return domainToSearch;
	}
	public void setDomainToSearch(String domainToSearch) {
		this.domainToSearch = domainToSearch;
	}
	public boolean isRelationFull() {
		return relationFull;
	}
	public void setRelationFull(boolean relationFull) {
		this.relationFull = relationFull;
	}

	public Hashtable getCardin() {
		return cardin;
	}
	public void setCardin(Hashtable cardin) {
		this.cardin = cardin;
	}
	public String getCardinArray() {
		return cardinArray;
	}
	public void setCardinArray(String cardinArray) {
		this.cardinArray = cardinArray;
	}
	
	
} // end class
