package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBmap;
import cmdbuild.utils.Settings;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.InheritsBean;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class DomainForm extends ActionForm {
	
	static final long serialVersionUID = 1L;
	private String method;
	private String className;
	private String directDescription;
	private String inverseDescription;
	private String startClass;
	private String endClass;
	private String cardinality;
	private Vector domainBeanVector;
	private String target; // to manage user's click
	private String superClassDomain; // session object 
	private String superClassFilter; // form object
	private boolean inheritsFromClass;


	public DomainForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		
		System.out.println("**DOMAINFORM RESET**");
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		} else if (request.getSession().getAttribute("class") != null) {
			className = (String)request.getSession().getAttribute("class");
		} else {
			Settings sett = (Settings)request.getSession().getAttribute("settings");
			className = sett.getStartingClass();
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
        CMDBmap MAP = new CMDBmap(db);
		InheritsBean inh = null;
		try {
			inh = CMDB.selectSuperClass(className);
		} catch (SQLException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		if (inh.getParent().equals("Class")){
			inheritsFromClass=true;
		} else {
			inheritsFromClass=false;
		}
        // creating a tree of this class       
        Hashtable pt = new Hashtable();  // key = child   value = parent
        Vector ptv = null;
        try {
			ptv = CMDB.selectClassTree();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
        Enumeration en = ptv.elements();
        inh = null;
		while (en.hasMoreElements()){
			inh = (InheritsBean)en.nextElement();
			pt.put(inh.getChild(),inh.getParent());
		}
		String targ = className;
		HashSet ptset = new HashSet();
		while (pt.containsKey(targ)){
			ptset.add(targ);
			targ = (String)pt.get(targ);
		}
		Vector dvett = null;
		domainBeanVector = new Vector();
		try {
			dvett = MAP.selectAllDomain();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		if (request.getSession().getAttribute("superClassDomain")==null){ // first time, check=on
			superClassDomain = "on";
			request.getSession().setAttribute("superClassDomain",superClassDomain);	
		} else {
			superClassDomain = (String)request.getSession().getAttribute("superClassDomain");
		}
		if (superClassDomain.equals("")){ // class domains
			en = dvett.elements();
			DomainBean dm = null;
			while(en.hasMoreElements()){
				dm = (DomainBean)en.nextElement();
				if (dm.getStartClass().equals(className) || dm.getEndClass().equals(className)){
					domainBeanVector.add(dm);
				}
			}
		} else { // class and superclass domains
			en = dvett.elements();
			DomainBean dm = null;
			while(en.hasMoreElements()){
				dm = (DomainBean)en.nextElement();
				if (ptset.contains(dm.getStartClass()) || ptset.contains(dm.getEndClass())){
					domainBeanVector.add(dm);
				}
			}
		}
		System.out.println(superClassDomain);
		request.setAttribute("domainBeanVector", domainBeanVector);
	}

	public String getMethod() {
		return method;
	}

	public void setMethod(String method) {
		this.method = method;
	}

	public String getName() {
		return className;
	}

	public void setName(String name) {
		this.className = name;
	}

	public Vector getDomainBeanVector() {
		return domainBeanVector;
	}

	public void setDomainBeanVector(Vector domainBeanVector) {
		this.domainBeanVector = domainBeanVector;
	}

	public String getDirectDescription() {
		return directDescription;
	}

	public void setDirectDescription(String directDescription) {
		this.directDescription = directDescription;
	}

	public String getEndClass() {
		return endClass;
	}

	public void setEndClass(String endClass) {
		this.endClass = endClass;
	}

	public String getInverseDescription() {
		return inverseDescription;
	}

	public void setInverseDescription(String inverseDescription) {
		this.inverseDescription = inverseDescription;
	}

	public String getStartClass() {
		return startClass;
	}

	public void setStartClass(String startClass) {
		this.startClass = startClass;
	}

	public String getTarget() {
		return target;
	}
	public void setTarget(String target) {
		this.target = target;
	}
	public String getSuperClassFilter() {
		return superClassFilter;
	}
	public void setSuperClassFilter(String superClassFilter) {
		this.superClassFilter = superClassFilter;
	}
	public String getSuperClassDomain() {
		return superClassDomain;
	}
	public void setSuperClassDomain(String superClassDomain) {
		this.superClassDomain = superClassDomain;
	}
	public String getCardinality() {
		return cardinality;
	}
	public void setCardinality(String cardinality) {
		this.cardinality = cardinality;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public boolean isInheritsFromClass() {
		return inheritsFromClass;
	}
	public void setInheritsFromClass(boolean inheritsFromClass) {
		this.inheritsFromClass = inheritsFromClass;
	}
	
	
} // end of class
