package cmdbuild.action_forms;
import java.sql.SQLException;
import java.util.*;

import cmdbuild.utils.MultiLanguage;
import cmdbuild.wizards.importutils.ImportLine;
import cmdbuild.wizards.importutils.ImportTable;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class ImportPopupForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private ImportTable it;
	private String className;
	private MultiLanguage multilanguage;
	private CMDBclass CMDB;
	private CMDBlookup LOOKUP;
	private Vector attributeVector;
	private Vector lookupVector;
	private String fieldname; 

	public ImportPopupForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		
		System.out.println("**IMPORTPOPUP RESET**");
		
		if (request.getSession().getAttribute("importTable")!=null){
			it = (ImportTable) request.getSession().getAttribute("importTable");
			System.out.println("getting it from session");
			System.out.println("it.size="+it.getLinesVector().size());
		} 
		multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		className = request.getParameter("class");
		if (CMDB==null){
			CMDB = new CMDBclass(db);
		}
		if (LOOKUP==null){
			LOOKUP = new CMDBlookup(db);
		}
		try {
			attributeVector = CMDB.selectAllAttribute(className,"rw");
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		lookupVector = new Vector();
		Vector options= null;
		AttributeBean ab = null;
		Enumeration enu = null;
		if (attributeVector!=null){
			enu = attributeVector.elements();
			Hashtable hash = new Hashtable();
			while (enu.hasMoreElements()){
				ab = (AttributeBean)enu.nextElement();
				if (ab.getType().equals("lookup")){
					try {
						if (!hash.containsKey(ab.getLookup())){ // don't get duplicates
							System.out.println("Getting lookup for "+ab.getLookup());
							options = LOOKUP.selectLookupByType(ab.getLookup());
							hash.put(ab.getLookup(),ab.getLookup());
						}
						//System.out.println("options.size="+options.size());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					if (options!=null){
						lookupVector.addAll(options);
					}
				}
			}
		}
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		return errors;
	}
	
	public String toForm(){
		Hashtable norepeat = null;
		String HTMLtext = "";
		AssetBean as = null;
    	HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
		// creating header of the table
		Enumeration en = it.getHeaderVector().elements();
		while (en.hasMoreElements()){
			as = (AssetBean)en.nextElement();
			if (!as.isToDelete()){
				HTMLtext+="<th>"+as.getValue()+"</th>";
			} else {
				HTMLtext+="<th style=\"color:red\">"+as.getValue()+"</th>";
			}
 		}
 		HTMLtext+="\n";
 		// creating the table
 		String value="";
 		Enumeration enr = it.getLinesVector().elements();
 		ImportLine il = null;
 		int nlines = 0;
 		int ncolumns = 0;
 		while (enr.hasMoreElements()){
 			nlines++;
			il = (ImportLine) enr.nextElement();
			System.out.println("il.size="+il.getLineVector().size());
 			Enumeration eni = il.getLineVector().elements();
 			ncolumns = 0;
			HTMLtext+="<tr>";
			while(eni.hasMoreElements()){
				ncolumns++;
				as = (AssetBean)eni.nextElement();
				fieldname="y"+nlines+"x"+ncolumns;
				norepeat = new Hashtable();
				System.out.println("name="+as.getName()+" type="+as.getType()+" value="+as.getValue());
				if (as.getType()!=null && as.getType().equals("lookup")){
					HTMLtext+="<td><select name=\""+fieldname+"\">";
					Enumeration enl = lookupVector.elements();
					LookupBean lb = null;
					// adding a default null value
					if (as.isToDelete()){
						HTMLtext+="<option></option>";	
					}
					while ( (enl!=null) && (enl.hasMoreElements()) ){
						lb = (LookupBean)enl.nextElement();
						if (lb.getType().equals(as.getLookup())){
							if (!norepeat.containsKey(lb.getId()+"")){
								if (as.getValue()!=null && as.getValue().equals(lb.getDescription())){
									HTMLtext+="<option selected>"+lb.getDescription()+"</option>";	
								} else {
									HTMLtext+="<option>"+lb.getDescription()+"</option>";
								}
								norepeat.put(lb.getId()+"",lb.getId()+"");
							}
						}
					}
					HTMLtext+="</select></td>";
				} else if(as.getType()!=null && as.getType().equals("date") ){
					// reset field if isn't valid
					if (as.isToDelete()){
						as.setValue("");
					}
					String val="";
					if (as.getValue()==null) {
						val = "";
					} else {
						val = as.getValue(); 
					}
					HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document.importPopupForm."+fieldname+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td>";
				} else if(as.getType()!=null && as.getType().equals("timestamp")){
					// reset field if isn't valid
					if (as.isToDelete()){
						as.setValue("");
					}
					String val="";
					if (as.getValue()==null) {
						val = "";
					} else {
						val = as.getValue(); 
					}
					HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document.importPopupForm."+fieldname+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td>";
				} else if(as.getType()!=null && as.getType().equals("text")){
					// reset field if isn't valid
					if (as.isToDelete()){
						as.setValue("");
					}
					String val="";
					if (as.getValue()==null) {
						val = "";
					} else {
						val = as.getValue(); 
					}
					HTMLtext+="<td><textarea name=\""+fieldname+"\" cols=\"25\" rows=\"2\">"+val+"</textarea></td>";
				} else if (as.getType()!=null && as.getType().equals("bool")){
					HTMLtext+="<td><select name=\""+fieldname+"\">";
					if (as.getValue()!= null && (as.getValue().equals("t") || as.getValue().equals("true"))){
						HTMLtext+="<option value=\"true\">S</option><option value=\"false\">N</option>";
					} else if (as.getValue()!= null && (as.getValue().equals("f") || as.getValue().equals("false"))){
						HTMLtext+="<option value=\"false\">N</option><option value=\"true\">S</option>";
					} else {
						HTMLtext+="<option></option><option value=\"true\">S</option><option value=\"false\">N</option>";
					}
					HTMLtext+="</select></td>";
				} else if (as.getType()!=null && as.getType().equals("varchar")){
					// reset field if isn't valid
					if (as.isToDelete()){
						as.setValue("");
					}
					HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+as.getValue()+"\" maxlength=\""+as.getLength()+"\"></td>";	
				} else  if (as.getType()!=null && ( as.getType().equals("numeric") || as.getType().equals("float8") || as.getType().equals("int4") )){ // numeric types
					// reset field if isn't valid
					if (as.isToDelete()){
						as.setValue("");
					}
					HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+as.getValue()+"\"></td>";
				} else {
					/*
					// reset field if isn't valid
					if (as.isToDelete()){
						as.setValue("");
					}
					*/
					if (value==null || value.equals("")){
						HTMLtext+="<td>&nbsp;</td>";
					} else if(as.isToDelete()){
						HTMLtext+="<td style=\"color:red\">"+value+"</td>";
					} else {
						HTMLtext+="<td>"+value+"</td>";
					}
				}
			}
			HTMLtext+="</tr>\n";
		}	
		HTMLtext+="</table>\n";
		HTMLtext += "\t<table><tr>";
 		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\" onclick=\"submit();\">";
		HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" class=\"button\" onclick=\"window.close();\">";	
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n</table>\n";
		HTMLtext += "<input type=\"hidden\" name=\"importok\" value=\""+it.isImportOk()+"\">";
		return HTMLtext;
		/*
		// creating the HTML code
		String HTMLtext = "";
		AssetBean as = null;
    	HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
		// creating header of the table
		Enumeration en = it.getHeaderVector().elements();
		while (en.hasMoreElements()){
			as = (AssetBean)en.nextElement();
			if (!as.isToDelete()){
				HTMLtext+="<th>"+as.getValue()+"</th>";
			} else {
				HTMLtext+="<th style=\"color:red\">"+as.getValue()+"</th>";
			}
 		}
 		HTMLtext+="\n";
 		// creating the table
 		Enumeration enit = it.getLinesVector().elements();
 		Enumeration enil = null;
 		ImportLine il = null;
 		int nlines = 0;
 		int ncolumns = 0;
 		Hashtable norepeat = null;
 		fieldname = "";
 		System.out.println("it.getLinesVector().size="+it.getLinesVector().size());
 		while (enit.hasMoreElements()){
 			nlines++;
			il = (ImportLine)enit.nextElement();
 			enil = il.getLineVector().elements();
 			ncolumns = 0;
			HTMLtext+="<tr>";
			System.out.println("il.getLineVector().size="+il.getLineVector().size());
			while(enil.hasMoreElements()){
				ncolumns++;
				as = (AssetBean)enil.nextElement();
				// reset field if isn't valid
				if (as.isToDelete()){
					as.setValue("");
				}
				fieldname="y"+nlines+"x"+ncolumns;
				norepeat = new Hashtable();
				System.out.println("name="+as.getName()+" type="+as.getType()+" value="+as.getValue());
				if (as.getType().equals("lookup")){
					HTMLtext+="<td><select name=\""+fieldname+"\">";
					Enumeration enl = lookupVector.elements();
					LookupBean lb = null;
					while ( (enl!=null) && (enl.hasMoreElements()) ){
						lb = (LookupBean)enl.nextElement();
						if (lb.getType().equals(as.getLookup())){
							if (!norepeat.containsKey(lb.getId()+"")){
								if (as.getValue()!=null && as.getValue().equals(lb.getDescription())){
									HTMLtext+="<option selected>"+lb.getDescription()+"</option>";	
								} else {
									HTMLtext+="<option>"+lb.getDescription()+"</option>";
								}
								norepeat.put(lb.getId()+"",lb.getId()+"");
							}
						}
					}
					HTMLtext+="</select></td>";
				} else if( as.getType().equals("date") ){
					String val="";
					if (as.getValue()==null) {
						val = "";
					} else {
						val = as.getValue(); 
					}
					HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document.importPopupForm."+fieldname+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td>";
				} else if( as.getType().equals("timestamp") ){
					String val="";
					if (as.getValue()==null) {
						val = "";
					} else {
						val = as.getValue(); 
					}
					HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document.importPopupForm."+fieldname+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td>";
				} else if( as.getType().equals("text") ){
					String val="";
					if (as.getValue()==null) {
						val = "";
					} else {
						val = as.getValue(); 
					}
					HTMLtext+="<td><textarea name=\""+fieldname+"\" cols=\"25\" rows=\"2\">"+val+"</textarea></td>";
				} else if (as.getType().equals("bool")){
					if (as.getValue()!= null && (as.getValue().equals("t") || as.getValue().equals("true"))){
						HTMLtext+="<td><select name=\""+fieldname+"\"><option>S</option><option>N</option></select></td>";
					} else { // f || false
						HTMLtext+="<td><select name=\""+fieldname+"\"><option>N</option><option>S</option></select></td>";
					}
				} else if (as.getType().equals("varchar")){
						HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+as.getValue()+"\" maxlength=\""+as.getLength()+"\"></td>";	
				} else { // numeric types
						HTMLtext+="<td><input type=\"text\" name=\""+fieldname+"\" value=\""+as.getValue()+"\"></td>";
				}
			}
			HTMLtext+="</tr>\n";
		}	
		HTMLtext+="</table>\n";
		HTMLtext += "\t<table><tr>";
 		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\" onclick=\"submit();\">";
		HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" class=\"button\" onclick=\"window.close();\">";	
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n</table>\n";
		HTMLtext += "<input type=\"hidden\" name=\"importok\" value=\""+it.isImportOk()+"\">";
		return HTMLtext;
		*/
	}

	public ImportTable getIt() {
		return it;
	}
	public void setIt(ImportTable it) {
		this.it = it;
	}
	public MultiLanguage getMultilanguage() {
		return multilanguage;
	}
	public void setMultilanguage(MultiLanguage multilanguage) {
		this.multilanguage = multilanguage;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	
} // end class
