package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;
import java.util.regex.Pattern;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.LookupBean;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class ModifyAttributeForm extends ActionForm {
	
	static final long serialVersionUID = 1L;
	private String method;
	private String className;
	private String name; // from request
	private String aName;
	private int aIndex;
	private int aDBindex;
	private String aDescription;
	private String aType;
	private String SQLtype;
	private String extraInput; // used to manage the extra attribute for each type of variable
	private String aLookup;
	private String aMandatory;
	private String aMode; // reserved/resd/write
	private String aDefault;
	private int aDefaultLookup; // value of default if the type is lookup, normally the value that as default=true in Lookup table / hidden tag
	private String aStatus;
	private String aComment; // used to change comment on columns
	private AttributeBean bean;
	private Collection lookupType;
	private String baseDSP;

	public ModifyAttributeForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		method = "";
		aType = "";
		aName = "";
		aDescription = "";
		extraInput = "";
		aDefault = "";
		aMandatory = "";
		bean = null;
		
		System.out.println("**MODIFYATTRIBUTEFORM RESET**");
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
		} else if (request.getSession().getAttribute("class") != null ){
			className = (String)request.getSession().getAttribute("class");
		}
		if (request.getParameter("name") != null){
			name = request.getParameter("name");
			request.getSession().setAttribute("name",name);
		} else if (request.getSession().getAttribute("name") != null ){
			name = (String)request.getSession().getAttribute("name");
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
		if ((className != null) && (name != null)) {
			try {
				bean = CMDB.selectAttributeByName(className,name);	       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (bean!=null){
			this.aName = bean.getName();
			this.aIndex = bean.getIndex();
			this.aDBindex = bean.getDBIndex();
			this.aDescription = bean.getDescription();
			this.SQLtype = bean.getSQLType();
			this.aType= bean.getType();
			this.aLookup = bean.getLookup();
			this.extraInput = bean.getExtraInput(); // inserito 
			if (aType.equals("varchar")){
				this.extraInput= String.valueOf(bean.getLength());
			}
			this.aMandatory = bean.getMandatory();
			this.aMode = bean.getMode();
			LookupBean lb = null;
			Vector lookupVector = null;
			if (aLookup!=null && aType.equals("lookup")){
				try {
					lookupVector = LOOKUP.selectLookupByType(aLookup);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else {
				this.aDefault = bean.getDefaultValue();
			}
			if (lookupVector!= null){
				lb = (LookupBean)lookupVector.elementAt(0);
				aDefault=lb.getDescription();
				aDefaultLookup=lb.getId();
				Enumeration en = lookupVector.elements();
				while(en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					if (lb.isDefaultValue()){
						aDefault=lb.getDescription();
						aDefaultLookup=lb.getId();
						break;
					}
				}
			}
			this.baseDSP = bean.getBaseDSP();
			this.aStatus = bean.getStatus();
			this.aComment= bean.getComment();
		}
		
		if ( lookupType == null ) {
	    	lookupType = new ArrayList();
			try {
				lookupType = LOOKUP.selectAllLookup() ;		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		Vector attributeBeanVector = null;
		CMDBclass CMDB = new CMDBclass(db);
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"all") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ActionErrors errors = new ActionErrors();
		if (aName == null || aName.trim().equals("")){
			errors.add("aName", new ActionMessage("name.required"));
		} else if (!Pattern.matches("[a-zA-Z0-9]+",aName)){
			errors.add("aName", new ActionMessage("name.alfanumeric"));
		}
		if (aName != null || !aName.trim().equals("")){
			Enumeration en = attributeBeanVector.elements();
			AttributeBean atb = new AttributeBean();
			while(en.hasMoreElements()){
				atb = (AttributeBean)en.nextElement();
				if (atb.getName().equals(aName) && !atb.getName().equals(name)){
					errors.add("Nome esiste", new ActionMessage("name.exists"));
					break;
				}
			}
		}
		if (aDescription == null || aDescription.trim().equals("")){
			errors.add("aDescription", new ActionMessage("description.required"));
		}
		if (aType.equals("varchar")){
			if (extraInput==null ||  extraInput.trim().equals("")) {
				errors.add("aType", new ActionMessage("length.required"));
			}
			int temp = 0;
			try {
				temp = Integer.parseInt(extraInput);
				if (temp<1){
					errors.add("extraInput", new ActionMessage("length.to.integer"));
				}
			} catch (NumberFormatException e){
				errors.add("extraInput", new ActionMessage("length.to.integer"));
			}
 		}
		if (aType.equals("numeric")){
			if (extraInput==null ||  extraInput.trim().equals("")) {
				errors.add("aType", new ActionMessage("precision.required"));
			}
			double d;
			try {
				d = Double.parseDouble(extraInput);
				if (d<1 || d>1000){
					errors.add("aType", new ActionMessage("precision.range"));
				}
				String dstring = Double.toString(d);
				int a=(int)dstring.charAt(0);
				int b=(int)dstring.charAt(2);
				if (a<b){
					errors.add("aType", new ActionMessage("precision.invalid"));
				}
			} catch (NumberFormatException e){
				errors.add("aType", new ActionMessage("precision.to.double"));
			}
 		}
		if (aMandatory.equals("Y")){
			if (aDefault==null ||  aDefault.trim().equals("")) {
				errors.add("aMandatory", new ActionMessage("default.required"));
			}
			if (aType.equals("int4")){
				//int i;
				try {
					Integer.parseInt(aDefault);
				} catch (NumberFormatException e){
					errors.add("aDefault", new ActionMessage("precision.to.integer"));
				}
	 		} // end numeric
			if (aType.equals("float8")){
				//double d;
				try {
					Double.parseDouble(aDefault);
				} catch (NumberFormatException e){
					errors.add("aDefault", new ActionMessage("precision.to.double"));
				}
	 		} // end numeric
			if (aType.equals("numeric")){
				//double d;
				try {
					Double.parseDouble(aDefault);
				} catch (NumberFormatException e){
					errors.add("aDefault", new ActionMessage("precision.to.double"));
				}
	 		} // end numeric
		} // end mandatory
		//  add if statement for category and status
		return errors;
	}
	
	public String getADefault() {
		return aDefault;
	}

	public void setADefault(String default1) {
		aDefault = default1;
	}

	public String getADescription() {
		return aDescription;
	}

	public void setADescription(String description) {
		aDescription = description;
	}

	public String getAStatus() {
		return aStatus;
	}

	public void setAStatus(String status) {
		aStatus = status;
	}

	public String getAType() {
		return aType;
	}

	public void setAType(String type) {
		aType = type;
	}

	public String getMethod() {
		return method;
	}

	public void setMethod(String method) {
		this.method = method;
	}

	public String getAName() {
		return aName;
	}

	public void setAName(String name) {
		aName = name;
	}

	public Collection getLookupType() {
		return lookupType;
	}

	public void setLookupType(Collection lookupType) {
		this.lookupType = lookupType;
	}

	public String getExtraInput() {
		return extraInput;
	}

	public void setExtraInput(String extraInput) {
		this.extraInput = extraInput;
	}

	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	public String getAMandatory() {
		return aMandatory;
		
	}

	public void setAMandatory(String mandatory) {
		aMandatory = mandatory;
	}

	public String getALookup() {
		return aLookup;
		
	}

	public void setALookup(String lookup) {
		aLookup = lookup;
	}

	public AttributeBean getBean() {
		return bean;
	}

	public void setBean(AttributeBean bean) {
		this.bean = bean;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getSQLtype() {
		return SQLtype;
	}

	public void setSQLtype(String ltype) {
		SQLtype = ltype;
	}

	public void setAIndex(int index) {
		aIndex = index;
	}

	public int getADBindex() {
		return aDBindex;
	}

	public void setADBindex(int bindex) {
		aDBindex = bindex;
	}

	public int getAIndex() {
		return aIndex;
	}
	public String getBaseDSP() {
		return baseDSP;
	}
	public void setBaseDSP(String baseDSP) {
		this.baseDSP = baseDSP;
	}
	public String getAMode() {
		return aMode;
	}
	public void setAMode(String mode) {
		aMode = mode;
	}
	public String getAComment() {
		return aComment;
	}
	public void setAComment(String comment) {
		aComment = comment;
	}
	public int getADefaultLookup() {
		return aDefaultLookup;
	}
	public void setADefaultLookup(int defaultLookup) {
		aDefaultLookup = defaultLookup;
	}
	

} // end of class
