package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;
import cmdbuild.utils.Settings;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class NoteForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String name;
	private String mode;
	private String classDescription="";
	private String method;
	private LabelsBean labelsBean;
	private String notes;
	private HTMLclass presentation; // object that generates HTML code
	private Vector attributeBeanVector;
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector lookupVector;
	private Vector rowIdVector; // contains all the row from the query
	private int currentPage=1;  // the first page corrisponds to vector[0]
	private int totalPages=0;
	private int rowId;  // contains the real id of the row
	private String manager;

	public NoteForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		//name = "";
		//asset = null;
		
		System.out.println("**NOTE RESET**");
		if (request.getParameter("class") != null){
			name = request.getParameter("class");
			request.getSession().setAttribute("class",name);
		} else if (request.getSession().getAttribute("class") != null){
 			name = (String)request.getSession().getAttribute("class");
		} else {
			Settings sett = (Settings)request.getSession().getAttribute("settings");
			name = sett.getStartingClass();
		}
		if (request.getParameter("page") != null){
			currentPage = Integer.parseInt(request.getParameter("page"));
			request.getSession().setAttribute("page",""+currentPage);
		} else if (request.getSession().getAttribute("page") != null){
 			currentPage = Integer.parseInt((String) request.getSession().getAttribute("page"));
		}
		if (request.getParameter("mode") != null){
			mode = request.getParameter("mode");
			request.getSession().setAttribute("mode",mode);
		} else if (request.getSession().getAttribute("mode") != null){
			mode = (String) request.getSession().getAttribute("mode");
		} else {
			mode="";
		}
		System.out.println("name="+name+" currentPage="+currentPage+" mode="+mode);
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		// *** managing filter ***
		String baseQuery = "";
		// replacing select parameters with "Id"
		baseQuery = "SELECT \"Id\" FROM \""+name+"\" WHERE \"Status\"='A'";
        Hashtable filter = null;
        FilterBean fb = null;
        CMDBclass CMDB = new CMDBclass(db);
        if (CMDB.getBean()==null){
        	try {
				CMDB.setBean(CMDB.selectClassByName(name));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        }
        if (request.getSession().getAttribute("filter")!=null){
        	filter = (Hashtable)request.getSession().getAttribute("filter");
        	if (filter.containsKey(name)){
        		fb = (FilterBean)filter.get(name);
        		try {
            		rowIdVector = CMDB.selectCardsId(fb.getQuery());
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	} else {
        		try {
            		rowIdVector = CMDB.selectCardsId(baseQuery);
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	}
        } else {
    		try {
        		rowIdVector = CMDB.selectCardsId(baseQuery);
    		} catch (SQLException e) {
    			e.printStackTrace();
    		}
        }
        
        totalPages = rowIdVector.size();
        if (totalPages!=0){
			rowId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
		} else { // There aren't cards
			currentPage = 0;
		}

		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(name,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		// searching for baseDSPs
		Enumeration en = attributeBeanVector.elements();
		AttributeBean atb = null;
		boolean baseDSPs = false;
		while (en.hasMoreElements()){
			atb = (AttributeBean)en.nextElement();
			if (atb.getBaseDSP().equals("true")){
				baseDSPs = true;
				break;
			}
		}
		if (baseDSPs){
			try {
				columnVector = CMDB.selectCard(name,rowId,attributeBeanVector);		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (columnVector==null){System.out.println("columnVector  nullo!");}
			// creating lookupVector if there are lookups
			Enumeration enu = columnVector.elements();
			lookupVector = new Vector();
			AssetBean ab = null;
			Vector options= null;
			if (enu==null){ System.out.println("enum  nullo"); }
			CMDBlookup LOOKUP = new CMDBlookup(db);
			while (enu.hasMoreElements()){
				ab = (AssetBean)enu.nextElement();
				if (ab.getType().equals("lookup")){
					try {
						System.out.println("Getting lookup for "+ab.getLookup());
						options = LOOKUP.selectLookupByType(ab.getLookup());
						//System.out.println("options.size="+options.size());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					lookupVector.addAll(options);
				}
			}
			System.out.println("lookup.size="+lookupVector.size());
		}
		try {
			labelsBean = CMDB.selectCardLabels(name,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		// Creating card Asset
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		manager = CMDB.getBean().getManager();
		presentation = (HTMLclass)CMDB.getPresentation();
		try {
			notes = CMDB.getCardNotes(name,rowId);		       
		} catch (SQLException e) {
			// this class has no field named Notes
			notes = null;
			//e.printStackTrace();
		}
		// Creating card Asset
		//asset = new Asset(columnVector,lookupVector,notes);
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setNotes(notes);
		presentation.setUser(user);
		presentation.setClassName(name);
		presentation.getHeader().getCreate().setVisible(false);
		if (user.isAllowed(name,2)){
			presentation.getHeader().getModify().setUrl("note.jsp?class="+name+"&mode=modify&page="+currentPage);
		} else {
			presentation.getHeader().getModify().setUrl("javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');");
		}
		presentation.getHeader().getDelete().setVisible(false);
		presentation.getHeader().getFilter().setVisible(false);
		presentation.getHeader().getNofilter().setVisible(false);
		// settings arrows
		if (currentPage==0){
			presentation.getHeader().getFirst().setUrl("note.jsp?class="+name+"&page=0");
			presentation.getHeader().getPrev().setUrl("note.jsp?class="+name+"&page=0");
			presentation.getHeader().getNext().setUrl("note.jsp?class="+name+"&page=0");
		} else if (currentPage==1){
			presentation.getHeader().getFirst().setUrl("note.jsp?class="+name+"&page=1");
			presentation.getHeader().getPrev().setUrl("note.jsp?class="+name+"&page=1");
			presentation.getHeader().getNext().setUrl("note.jsp?class="+name+"&page=2");
		} else if(currentPage==totalPages) {
			presentation.getHeader().getFirst().setUrl("note.jsp?class="+name+"&page=1");
			presentation.getHeader().getPrev().setUrl("note.jsp?class="+name+"&page="+(totalPages-1));
			presentation.getHeader().getNext().setUrl("note.jsp?class="+name+"&page="+totalPages);
		} else {
			presentation.getHeader().getFirst().setUrl("note.jsp?class="+name+"&page=1");
			presentation.getHeader().getPrev().setUrl("note.jsp?class="+name+"&page="+(currentPage-1));
			presentation.getHeader().getNext().setUrl("note.jsp?class="+name+"&page="+(currentPage+1));
		}
		presentation.getHeader().getLast().setUrl("note.jsp?class="+name+"&page="+totalPages);
		// setting current page
		presentation.getHeader().getPage().setCurrent(currentPage);
		presentation.getHeader().getPage().setTotal(totalPages);
		presentation.getHeader().getCheckFilter().setVisible(false);
		if (currentPage!=0){
			// setting label
			presentation.getHeader().getLabel().setLabel(classDescription+" - "+labelsBean.getCode()+"<BR>"+labelsBean.getDescription());
		} else {
			presentation.getHeader().getLabel().setLabel(" - ");
		}
		/*
		// disable operations if className=Asset
		if (CMDB.getBean().isSuperClass()){
			presentation.getHeader().getCreate().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
			presentation.getHeader().getModify().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
			presentation.getHeader().getDelete().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
		}
		*/
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**NOTE VALIDATE**");
		ActionErrors errors = new ActionErrors();
		return errors;
	}
	
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public LabelsBean getLabelsBean() {
		return labelsBean;
	}
	public void setLabelsBean(LabelsBean labelsBean) {
		this.labelsBean = labelsBean;
	}
	public String getNotes() {
		return notes;
	}
	public void setNotes(String notes) {
		this.notes = notes;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public String getManager() {
		return manager;
	}
	public void setManager(String manager) {
		this.manager = manager;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}

} // end class
