package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class PopupInfoHistoryForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String className;
	private String classDescription="";
	private String method;
	private String mode;
	private String targetClass; // used to implement "go to page" 
	private String targetObjId; // used to implement "go to page"
	private String search; 
	private HTMLclass presentation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector lookupVector;
	private Vector historyVector;
	private Vector mapVector;
	private int rowId;  // contains the real id of the row
	private LabelsBean labelsBean; 

	public PopupInfoHistoryForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		historyVector = new Vector();
		// setting in the session historyForm
		request.getSession().setAttribute("historyForm",this);
				
		System.out.println("**HISTORYFORM RESET**");
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
		}
		if (request.getParameter("objid") != null){
			rowId = Integer.parseInt(request.getParameter("objid"));
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
		if (CMDB.getBean()==null){
			try {
				CMDB.setBean(CMDB.selectClassByName(className));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		String baseQuery = "";
		baseQuery = "SELECT \"Id\" FROM \""+className+"\" WHERE \"Status\"='A'";
   		try {
       		rowIdVector = CMDB.selectCardsId(baseQuery);
   		} catch (SQLException e) {
   			e.printStackTrace();
   		}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		try {
			columnVector = CMDB.selectCard(className,rowId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		
		// creating lookupVector if there are lookups
		Enumeration enu = columnVector.elements();
		lookupVector = new Vector();
		AssetBean ab = null;
		Vector options= null;
		if (enu==null){ System.out.println("enum  nullo"); }
		Hashtable hash = new Hashtable();
		CMDBlookup LOOKUP = new CMDBlookup(db);
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType().equals("lookup")){
				try {
					if (!hash.containsKey(ab.getLookup())){ // don't get duplicates
						System.out.println("Getting lookup for "+ab.getLookup());
						options = LOOKUP.selectLookupByType(ab.getLookup());
						hash.put(ab.getLookup(),ab.getLookup());
					}
					//System.out.println("options.size="+options.size());
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if (options!=null){
					lookupVector.addAll(options);
				}
			}
		}
		System.out.println("lookup.size="+lookupVector.size());
		CMDBmap MAP = new CMDBmap(db);
		// getting class ID
		int classId = 0;
		try {
			classId = CMDB.selectClassByName(className).getId();		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting _history 
		try {
			historyVector = CMDB.selectHistory(className,classId,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting history of relations
		try {
			mapVector = MAP.selectHistoryRelations(classId,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		historyVector.addAll(mapVector);
		// getting labels
		try {
			labelsBean = CMDB.selectCardLabels(className,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// Creating card History
		//history = new History(historyVector,columnVector,lookupVector);
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setHistoryVector(historyVector);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		// this is passed to popup 
		presentation.setClassName(className);
		presentation.getHeader().setVisible(false);
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		//String tname = "";
		String target="";
		Enumeration en = columnVector.elements();
		while (en.hasMoreElements()){
			ab = (AssetBean)en.nextElement();
			if (ab.getMandatory().equals("Y")){
				//tname = ab.getName();
				target= arg1.getParameter(target);
				System.out.println("target value="+target);
				if (target == null || target.trim().equals("")){
					errors.add("target", new ActionMessage("form.field.required",target));
				}
			}
		}
		return errors;
	}
	
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}

	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public Vector getMapVector() {
		return mapVector;
	}
	public void setMapVector(Vector mapVector) {
		this.mapVector = mapVector;
	}
	public String getTargetClass() {
		return targetClass;
	}
	public void setTargetClass(String targetClass) {
		this.targetClass = targetClass;
	}
	public String getTargetObjId() {
		return targetObjId;
	}
	public void setTargetObjId(String targetObjId) {
		this.targetObjId = targetObjId;
	}
	public Vector getHistoryVector() {
		return historyVector;
	}
	public void setHistoryVector(Vector historyVector) {
		this.historyVector = historyVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public LabelsBean getLabelsBean() {
		return labelsBean;
	}
	public void setLabelsBean(LabelsBean labelsBean) {
		this.labelsBean = labelsBean;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}

} // end class
