package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class PopupInfoNoteForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String className;
	private String classDescription="";
	private String method;
	private LabelsBean labelsBean;
	private String notes;
	private HTMLclass presentation; // object that generates HTML code
	private Vector attributeBeanVector;
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector lookupVector;
	private int rowId;  // contains the real id of the row
	private String manager;

	public PopupInfoNoteForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {

		System.out.println("**POPUPINFONOTE RESET**");
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		}
		if (request.getParameter("objid") != null){
			rowId = Integer.parseInt(request.getParameter("objid"));
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		manager = CMDB.getBean().getManager();
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		// searching for baseDSPs
		Enumeration en = attributeBeanVector.elements();
		AttributeBean atb = null;
		boolean baseDSPs = false;
		while (en.hasMoreElements()){
			atb = (AttributeBean)en.nextElement();
			if (atb.getBaseDSP().equals("true")){
				baseDSPs = true;
				break;
			}
		}
		if (baseDSPs){
			try {
				columnVector = CMDB.selectCard(className,rowId,attributeBeanVector);		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (columnVector==null){System.out.println("columnVector  nullo!");}
			// creating lookupVector if there are lookups
			Enumeration enu = columnVector.elements();
			lookupVector = new Vector();
			AssetBean ab = null;
			Vector options= null;
			if (enu==null){ System.out.println("enum  nullo"); }
			CMDBlookup LOOKUP = new CMDBlookup(db);
			while (enu.hasMoreElements()){
				ab = (AssetBean)enu.nextElement();
				if (ab.getType().equals("lookup")){
					try {
						System.out.println("Getting lookup for "+ab.getLookup());
						options = LOOKUP.selectLookupByType(ab.getLookup());
						//System.out.println("options.size="+options.size());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					lookupVector.addAll(options);
				}
			}
			System.out.println("lookup.size="+lookupVector.size());
		}
		try {
			labelsBean = CMDB.selectCardLabels(className,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			notes = CMDB.getCardNotes(className,rowId);		       
		} catch (SQLException e) {
			// this class has no field named Notes
			notes = null;
			//e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		// Creating card Asset
		//asset = new Asset(columnVector,lookupVector,notes);
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setNotes(notes);
		presentation.setUser(user);
		presentation.setClassName(className);
		presentation.getHeader().setVisible(false);
		presentation.setDisableEditing(true);
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**NOTE VALIDATE**");
		ActionErrors errors = new ActionErrors();
		return errors;
	}
	
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public LabelsBean getLabelsBean() {
		return labelsBean;
	}
	public void setLabelsBean(LabelsBean labelsBean) {
		this.labelsBean = labelsBean;
	}
	public String getNotes() {
		return notes;
	}
	public void setNotes(String notes) {
		this.notes = notes;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public String getManager() {
		return manager;
	}
	public void setManager(String manager) {
		this.manager = manager;
	}

} // end class
