package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;
import cmdbuild.utils.Settings;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class SearchForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String name;
	private String classDescription;
	private String method;
	private String mode;
	private String search; 
	private HTMLclass presentation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector domainVector;
	private Vector searchRelationVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private int currentPage=1;  // the first page corrisponds to vector[0] / scope session
	private int totalPages=0;   // scope session
	private int subpage=1;       // used only in SearchForm / scope request
	private int totalSubpages=0; // used only in SearchForm / scope request
	private int rowId;  // contains the real id of the row
	private Collection classCollection; // only used in mode filter
	private String query; // the query used for the report page
	private Vector selectVector;
	private Vector reportVector; // matrix that contains reports to display 
	private String showAll; // hidden tag, used to show/unshow all fields in the search page 
	private Vector relationTips;
	private Hashtable tips;
	

	public SearchForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		//name = "";
		presentation = new HTMLclass();

		System.out.println("**SEARCHFORM RESET**");
	    DBService db = (DBService)servlet.getServletContext().getAttribute("db");
	    CMDBclass CMDB = new CMDBclass(db);
	    if ( classCollection == null) {
	    	classCollection = new ArrayList();
	    	try {
				classCollection = CMDB.selectAllClass();		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
	    if (request.getParameter("class") != null){
			name = request.getParameter("class");
			request.getSession().setAttribute("class",name);
		} else if (request.getSession().getAttribute("class") != null){
 			name = (String)request.getSession().getAttribute("class");
		} else { // default name if none is found
			Settings sett = (Settings)request.getSession().getAttribute("settings");
			name = sett.getStartingClass();
		}
	    if (CMDB.getBean()==null){
	    	try {
				CMDB.setBean(CMDB.selectClassByName(name));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		if (request.getParameter("page") != null){
			currentPage = Integer.parseInt(request.getParameter("page"));
			request.getSession().setAttribute("page",""+currentPage);
		} else if (request.getSession().getAttribute("page") != null){
			System.out.println("currentPage="+request.getSession().getAttribute("page"));
 			currentPage = Integer.parseInt((String) request.getSession().getAttribute("page"));
		}
		if (request.getParameter("mode") != null){
			mode = request.getParameter("mode");
			request.getSession().setAttribute("mode",mode);
			System.out.println("Setting mode="+mode);
		} else if (request.getSession().getAttribute("mode") != null){
			mode = (String) request.getSession().getAttribute("mode");
		} else { // patch
			mode="filter";
		}
		System.out.println("classe="+name+" currentPage="+currentPage+" mode="+mode);
		// getting supage
		int subpage=0;
		if (request.getParameter("subpage")!=null){
			subpage = Integer.parseInt(request.getParameter("subpage"));
		} else {
			if (currentPage!=0){
				subpage = currentPage/presentation.getResultsForPage();
				if (currentPage%presentation.getResultsForPage()!=0){
					subpage++;
				}
			}
		}

		// creating a select vector, contains elements to retrieve for the query select...
		try {
			attributeBeanVector = CMDB.selectAllAttribute(name,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// creating selectVector
		Vector vec = new Vector();
		selectVector = new Vector();
		AttributeBean id = new AttributeBean();
		id.setName("Id");
		id.setSQLType("int4");
		id.setType("int4");
		vec.add(id);
		id = new AttributeBean();
		id.setName("IdClass");
		id.setSQLType("int4");
		id.setType("int4");
		vec.add(id);
		vec.addAll(selectVector);
		selectVector = vec;
		Enumeration en2 = attributeBeanVector.elements();
		AttributeBean ab = null;
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription();
		}
		while (en2.hasMoreElements()){
			ab = (AttributeBean)en2.nextElement();
			if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
				if (ab.getBaseDSP().equals("true")){
 					selectVector.add(ab);
				}
			}
		}

		// *** managing filter ***
		String baseReportQuery = "";
		ab = null;
		Enumeration es = selectVector.elements();
		while(es.hasMoreElements()){
			ab = (AttributeBean)es.nextElement();
			if (baseReportQuery.equals("")){
				baseReportQuery = "SELECT \""+ab.getName()+"\"";
			} else {
				baseReportQuery +=", \""+ab.getName()+"\"";
			}
		}
		baseReportQuery = baseReportQuery+" FROM \""+name+"\" WHERE \"Status\"='A'"; 
		String baseQuery = "SELECT \"Id\" FROM \""+name+"\" WHERE \"Status\"='A'";
        Hashtable filter = null;
        FilterBean fb = null;
		int offset;
		if (subpage==0 || subpage==1){
			//subpage=1;
			offset=0;
		} else {
			offset=(subpage-1)*presentation.getResultsForPage();
		}
		if (mode.equals("show")){
			if (request.getSession().getAttribute("filter")!=null){
				System.out.println("there is a filter");
				filter = (Hashtable)request.getSession().getAttribute("filter");
				if (filter.containsKey(name)){
					System.out.println("found name in filter");
					fb = (FilterBean)filter.get(name);
					try {
						
						rowIdVector = CMDB.selectCardsId(fb.getQuery());
						reportVector = CMDB.selectCards(fb.getReportQuery(),selectVector,presentation.getResultsForPage(),offset);
						query = fb.getReportQuery();
					} catch (SQLException e) {
						e.printStackTrace();
					}
				} else {
					System.out.println("found name in filter");
					try {
						rowIdVector = CMDB.selectCardsId(baseQuery);
						reportVector = CMDB.selectCards(baseReportQuery,selectVector,presentation.getResultsForPage(),offset);	
						query = baseReportQuery;
					} catch (SQLException e) {
						e.printStackTrace();
					}
				}
			} else {
				System.out.println("there isn't a filter");
				try {
					rowIdVector = CMDB.selectCardsId(baseQuery);
					reportVector = CMDB.selectCards(baseReportQuery,selectVector,presentation.getResultsForPage(),offset);
					query = baseReportQuery;
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}
		CMDBlookup LOOKUP = new CMDBlookup(db);
		CMDBmap MAP = new CMDBmap(db);
        AssetBean asb = null;
		if (mode.equals("show")){
			// creating lookupVector if there are lookups
	        if (reportVector.size()>0){
	        	columnVector = (Vector)reportVector.elementAt(0);
	        }
			lookupVector = new Vector();
			Vector options= null;
			if (columnVector!=null){
				Enumeration enu = columnVector.elements();
				
				Hashtable hash = new Hashtable();
				while (enu.hasMoreElements()){
					asb = (AssetBean)enu.nextElement();
					if (asb.getType().equals("lookup")){
						try {
							if (!hash.containsKey(asb.getLookup())){ // don't get duplicates
								System.out.println("Getting lookup for "+asb.getLookup());
								options = LOOKUP.selectLookupByType(asb.getLookup());
								hash.put(asb.getLookup(),asb.getLookup());
							}
							//System.out.println("options.size="+options.size());
						} catch (SQLException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						if (options!=null){
							lookupVector.addAll(options);
						}
					}
				}
			}
			// creating couple_class_obj
			if (reportVector!=null){
				String couple_class_obj="";
				Vector encovett = null;
				AssetBean encoass = null;
				Enumeration en = reportVector.elements();
				while (en.hasMoreElements()){
					encovett = (Vector)en.nextElement();
					encoass = (AssetBean)encovett.elementAt(0); // Id
					if (!couple_class_obj.equals("")){
						couple_class_obj += " OR (idclass1="+encoass.getClassBean().getId()+" AND idobj1="+encoass.getValue()+")"; 
					} else { // couple_class_obj=""
						couple_class_obj = "(idclass1="+encoass.getClassBean().getId()+" AND idobj1="+encoass.getValue()+")"; 
					}
	 			}
				try {
					relationTips = MAP.selectRelationTips(couple_class_obj);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
	        System.out.println("reportVector.size()="+reportVector.size());
			totalPages = rowIdVector.size();
			if (reportVector!=null && reportVector.size()>totalPages){
				totalPages = reportVector.size();
			}
			if (rowIdVector==null){System.out.println("rowIdVector  nullo!");}
			if (rowIdVector.size()>0){
				if(currentPage < 1){
					currentPage = 1;
				} else if (currentPage>totalPages){
					currentPage = 1;
				}
				rowId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
			} else { // There aren't cards
				currentPage = 0;
			}
		}
		if (mode.equals("filter")){
			try {
				columnVector = CMDB.selectCard(name,rowId,attributeBeanVector);		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (columnVector==null){ // patch if there aren't clasess and data
				System.out.println("columnVector  nullo!");
				columnVector = new Vector();
			}
			// creating lookupVector if there are lookups
			Enumeration enu = columnVector.elements();
			lookupVector = new Vector();
			asb = null;
			Vector options= null;
			if (enu==null){ System.out.println("enum  nullo"); }
			Hashtable hash = new Hashtable();
			while (enu.hasMoreElements()){
				asb = (AssetBean)enu.nextElement();
				if (asb.getType().equals("lookup")){
					try {
						if (!hash.containsKey(asb.getLookup())){ // don't get duplicates
							System.out.println("Getting lookup for "+asb.getLookup());
							options = LOOKUP.selectLookupByType(asb.getLookup());
							hash.put(asb.getLookup(),asb.getLookup());
						}
						//System.out.println("options.size="+options.size());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					if (options!=null){
						lookupVector.addAll(options);
					}
				}
			}
			System.out.println("lookup.size="+lookupVector.size());
	        
			// creating a tree of this class       
	        Hashtable pt = new Hashtable();  // key = child   value = parent
	        Vector ptv = null;
	        try {
				ptv = CMDB.selectClassTree();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
	        Enumeration en = ptv.elements();
	        InheritsBean inh = null;
			while (en.hasMoreElements()){
				inh = (InheritsBean)en.nextElement();
				pt.put(inh.getChild(),inh.getParent());
			}
			String targ = name;
			HashSet ptset = new HashSet();
			while (pt.containsKey(targ)){
				ptset.add(targ);
				targ = (String)pt.get(targ);
			}
			DomainBean dm = null;
			domainVector = new Vector();
			try {
				domainVector = MAP.selectAllDomain();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			// creating vector of relations showed in the filter page
			Enumeration en3 = domainVector.elements();
			SearchRelationBean sr = null;
			searchRelationVector = new Vector();
			int i2 = 1;
			boolean addedThisLoop = false;
			while (en3.hasMoreElements()){
				dm = (DomainBean)en3.nextElement();
				addedThisLoop = false;
				if (ptset.contains(dm.getStartClass())){
					sr = new SearchRelationBean(dm.getDirectDescription(),"dom"+i2,dm.getEndClass(),true);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
					addedThisLoop = true;
				} 
				if (ptset.contains(dm.getEndClass())){
					if (addedThisLoop == true){
						i2++;
					}
					sr = new SearchRelationBean(dm.getInverseDescription(),"dom"+i2,dm.getStartClass(),false);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
				} 
				i2++;
			}
			
			// cleaning page when page=0
			asb = null;
			if (currentPage==0){
				Enumeration eni = columnVector.elements();
				asb = null;
				while (eni.hasMoreElements()){
					asb = (AssetBean)eni.nextElement();
					asb.setValue(null);
				}
			}
		}
		if (rowId==0){System.out.println("rowId  nullo!");}
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		// Creating card Search
		//presentation = new Search(name,classCollection,columnVector,lookupVector,searchRelationVector,reportVector,selectVector);
		// Creating card Asset
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setClassName(name);
		presentation.setClassCollection(classCollection);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setSearchRelationVector(searchRelationVector);
		presentation.setReportVector(reportVector);
		presentation.setThVector(selectVector);
		presentation.setTipsVector(relationTips);
		presentation.setUser(user);
		if (user.isAllowed(name,2)){
			presentation.getHeader().getCreate().setUrl("card.jsp?class="+name+"&mode=create");
		} else {
			presentation.getHeader().getCreate().setUrl("javascript:alert('Non hai i permessi necessari');");
		}
		presentation.getHeader().getModify().setVisible(false);
		// to switch from mode=show to mode=filter and viceversa
		if (mode.equals("show")){
			presentation.getHeader().getFilter().setUrl("search.jsp?class="+name+"&mode=filter&page="+currentPage);
		} else {
			presentation.getHeader().getFilter().setUrl("search.jsp?class="+name+"&mode=show&page="+currentPage);
		}
		presentation.getHeader().getNofilter().setUrl("javascript:searchForm.method.value='nofilter';searchForm.submit();");
		presentation.getHeader().getDelete().setVisible(false);
		if (mode.equals("show")){
			// settings arrows
			if (currentPage==0){
				presentation.getHeader().getFirst().setUrl("search.jsp?class="+name+"&mode=show&page=0");
				presentation.getHeader().getPrev().setUrl("search.jsp?class="+name+"&mode=show&page=0");
				presentation.getHeader().getNext().setUrl("search.jsp?class="+name+"&mode=show&page=0");
			} else if (currentPage==1){
				presentation.getHeader().getFirst().setUrl("search.jsp?class="+name+"&mode=show&page=1");
				presentation.getHeader().getPrev().setUrl("search.jsp?class="+name+"&mode=show&page=1");
				presentation.getHeader().getNext().setUrl("search.jsp?class="+name+"&mode=show&page=2");
			} else if(currentPage==totalPages) {
				presentation.getHeader().getFirst().setUrl("search.jsp?class="+name+"&mode=show&page=1");
				presentation.getHeader().getPrev().setUrl("search.jsp?class="+name+"&mode=show&page="+(totalPages-1));
				presentation.getHeader().getNext().setUrl("search.jsp?class="+name+"&mode=show&page="+totalPages);
			} else {
				presentation.getHeader().getFirst().setUrl("search.jsp?class="+name+"&mode=show&page=1");
				presentation.getHeader().getPrev().setUrl("search.jsp?class="+name+"&mode=show&page="+(currentPage-1));
				presentation.getHeader().getNext().setUrl("search.jsp?class="+name+"&mode=show&page="+(currentPage+1));
			}
			presentation.getHeader().getLast().setUrl("search.jsp?class="+name+"&mode=show&page="+totalPages);
			// setting current page
			presentation.getHeader().getPage().setCurrent(currentPage);
			presentation.getHeader().getPage().setTotal(totalPages);
			// checkfilter 
			presentation.getHeader().getCheckFilter().setVisible(false);
		} else { // mode = filter
			presentation.getHeader().getFirst().setUrl("javascript:alert('Esegui prima una ricerca');");
			presentation.getHeader().getPrev().setUrl("javascript:alert('Esegui prima una ricerca');");
			presentation.getHeader().getNext().setUrl("javascript:alert('Esegui prima una ricerca');");
			presentation.getHeader().getLast().setUrl("javascript:alert('Esegui prima una ricerca');");
			// setting current page
			presentation.getHeader().getPage().setVisible(false);
			// setting showAll checkbox
			presentation.getHeader().getCheckFilter().setVisible(true);
			presentation.getHeader().getCheckFilter().setName("");
			presentation.getHeader().getCheckFilter().setText("Mostra tutto");
			System.out.println("showAll is=");
			if (showAll!=null && showAll.equals("on")){
				presentation.getHeader().getCheckFilter().setChecked(true);
				presentation.getHeader().getCheckFilter().setOnClickAction("javascript:searchForm.method.value='display';showAll.value='';searchForm.submit();");
				presentation.setShowAll(true);
			} else {
				presentation.getHeader().getCheckFilter().setChecked(false);
				presentation.getHeader().getCheckFilter().setOnClickAction("javascript:searchForm.method.value='display';showAll.value='on';searchForm.submit();");
				presentation.setShowAll(false);
			}
		}
		//presentation.getLabel().setVisible(false);
		presentation.getHeader().getLabel().setLabel(multilanguage.getMessage("SearchForm.list")+": "+classDescription);
		// setting calendar reference
		presentation.setFormName("searchForm");
		// managing shows of 30 rows for page
		presentation.setSubpage(subpage);
		presentation.setPageToHighlight(currentPage);
		presentation.setTotalPages(totalPages);
		/*
		// disable operations if className=Asset
		if (name.equals("Asset")){
			presentation.getHeader().getCreate().setUrl("javascript:alert('Classe non modificabile');");
			presentation.getHeader().getModify().setUrl("javascript:alert('Classe non modificabile');");
			presentation.getHeader().getDelete().setUrl("javascript:alert('Classe non modificabile');");
		}
		*/
	}

	/*
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		System.out.println("Mode is "+mode);
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		String tname = "";
		String target="";
		Enumeration en = columnVector.elements();
		while (en.hasMoreElements()){
			ab = (AssetBean)en.nextElement();
			if (ab.getAMandatory().equals("Y")){
				tname = ab.getAName();
				target= arg1.getParameter(tname);
				System.out.println("target is "+tname+"target value="+target);
				if (target == null || target.trim().equals("")){ // ,tname
					errors.add(tname, new ActionMessage("par.required",tname));
				} else { // if there is something
					if (ab.getAType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tname));
						}
					} // end numeric
					if (ab.getAType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
					if (ab.getAType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
				} // end else	
			} else {  // not mandatory
				tname = ab.getAName();
				target= arg1.getParameter(tname);
				System.out.println("target value="+target);
				if (target != null && !target.trim().equals("")){ // if there is something
					if (ab.getAType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tname));
						}
					} // end numeric
					if (ab.getAType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
					if (ab.getAType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
				} // end else	
			}
		}
		return errors;
	}
	*/
	
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public Vector getDomainVector() {
		return domainVector;
	}
	public void setDomainVector(Vector domainVector) {
		this.domainVector = domainVector;
	}
	public Vector getSearchRelationVector() {
		return searchRelationVector;
	}
	public void setSearchRelationVector(Vector searchRelationVector) {
		this.searchRelationVector = searchRelationVector;
	}
	public Vector getReportVector() {
		return reportVector;
	}
	public void setReportVector(Vector reportVector) {
		this.reportVector = reportVector;
	}
	public Vector getSelectVector() {
		return selectVector;
	}
	public void setSelectVector(Vector selectVector) {
		this.selectVector = selectVector;
	}
	public int getSubpage() {
		return subpage;
	}
	public void setSubpage(int subpage) {
		this.subpage = subpage;
	}
	public int getTotalSubpages() {
		return totalSubpages;
	}
	public void setTotalSubpages(int totalSubpages) {
		this.totalSubpages = totalSubpages;
	}
	public String getQuery() {
		return query;
	}
	public void setQuery(String query) {
		this.query = query;
	}
	public String getShowAll() {
		return showAll;
	}
	public void setShowAll(String showAll) {
		this.showAll = showAll;
	}
	public Vector getRelationTips() {
		return relationTips;
	}
	public void setRelationTips(Vector relationTips) {
		this.relationTips = relationTips;
	}
	public Hashtable getTips() {
		return tips;
	}
	public void setTips(Hashtable tips) {
		this.tips = tips;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}

} // end class
