package cmdbuild.action_forms;

import cmdbuild.collection.ClassBean;

import java.io.File;
import java.sql.SQLException;
import java.util.Collection;
import java.util.LinkedList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.*;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.utils.Settings;

public class SetupForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private Settings sett;
	private String language;
	private boolean languagePrompt;
	private String startingClass;
	private CMDBclass CMDB;
	private Collection classCollection;
	private Collection languageCollection;
	private String cmdbRealPath;
	
	
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**SETUPFORM EXECUTE**");
		cmdbRealPath = request.getSession().getServletContext().getRealPath(request.getContextPath()); 
		cmdbRealPath = cmdbRealPath.substring(0,cmdbRealPath.lastIndexOf(File.separator));
		sett = new Settings(cmdbRealPath);
		language = sett.getLanguage();
		languagePrompt = sett.isLanguagePrompt();
		startingClass = sett.getStartingClass();
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        if (CMDB==null){
        	CMDB = new CMDBclass(db);	
        }
        if (classCollection==null){
        	classCollection = new LinkedList();
        	// adding null option
        	ClassBean cb = new ClassBean();
        	cb.setName("");
        	cb.setDescription("");
        	classCollection.add(cb);
        	Collection cl = null;
        	try {
				cl = CMDB.selectAllClass();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (cl!=null){
				classCollection.addAll(cl);
			}
        }
        if (languageCollection==null){
        	languageCollection = new LinkedList();
        	ClassBean cb = new ClassBean();
        	cb.setName("it");
        	cb.setDescription("it");
        	languageCollection.add(cb);
        	cb = new ClassBean();
        	cb.setName("en");
        	cb.setDescription("en");
        	languageCollection.add(cb);
        }
        		
	}

	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#validate(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		ActionErrors errors = new ActionErrors();
		errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("form.field.required", "Nome tabella"));
		//  add if statement for category and status
		return errors;
	}

	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public CMDBclass getCMDB() {
		return CMDB;
	}
	public void setCMDB(CMDBclass cmdb) {
		CMDB = cmdb;
	}
	public String getLanguage() {
		return language;
	}
	public void setLanguage(String language) {
		this.language = language;
	}
	public Collection getLanguageCollection() {
		return languageCollection;
	}
	public void setLanguageCollection(Collection languageCollection) {
		this.languageCollection = languageCollection;
	}
	public boolean isLanguagePrompt() {
		return languagePrompt;
	}
	public void setLanguagePrompt(boolean languagePrompt) {
		this.languagePrompt = languagePrompt;
	}
	public Settings getSett() {
		return sett;
	}
	public void setSett(Settings sett) {
		this.sett = sett;
	}
	public String getStartingClass() {
		return startingClass;
	}
	public void setStartingClass(String startingClass) {
		this.startingClass = startingClass;
	}
	public String getCmdbRealPath() {
		return cmdbRealPath;
	}
	public void setCmdbRealPath(String cmdbRealPath) {
		this.cmdbRealPath = cmdbRealPath;
	}
	
} // end of class
