package cmdbuild.action_forms;

import cmdbuild.db.DBService;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.*;

import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;
import cmdbuild.wizards.WizardManager;

public class WizardForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String method;
	private WizardManager wizard; // HTML producer 
	private String wizardName;
	private int wizardPage;
	private Vector domainVector;

	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**WIZARD RESET**");
	    if (request.getParameter("wizardname") != null){
			wizardName = request.getParameter("wizardname");
			//request.getSession().setAttribute("wizard",wiz);
	    } else if (request.getSession().getAttribute("wizardname") != null){
			wizardName = (String) request.getSession().getAttribute("wizardname");
		} else wizardName = "mr";
		wizardPage = 1;
	    if (request.getParameter("wizardpage") != null){
			wizardPage = Integer.parseInt(request.getParameter("wizardpage"));
			request.getSession().setAttribute("wizardpage",wizardPage+"");
	    } else if (request.getSession().getAttribute("wizardpage") != null){
			wizardPage = Integer.parseInt((String)request.getSession().getAttribute("wizardpage"));
		} 
	    DBService db = (DBService)servlet.getServletContext().getAttribute("db");
	    MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
	    if (request.getSession().getAttribute("wizard")!=null){
	    	wizard = (WizardManager)request.getSession().getAttribute("wizard");	
	    	System.out.println("getting wizard from session");
	    } else {
			wizard = new WizardManager(wizardName,db,multilanguage);
			// getting user from session
			SecurityDescriptor user = null;
			if (request.getSession().getAttribute("user")!=null){
				user = (SecurityDescriptor)request.getSession().getAttribute("user");
			}
			wizard.getWiz().setUser(user);
			request.getSession().setAttribute("wizard",wizard);
			System.out.println("creating wizard");
	    }
	    wizard.getDataForPage(request,wizardPage);
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		ActionErrors errors = new ActionErrors();
		System.out.println("**VALIDATE**");
		// validation for MR, last page
		String target = arg1.getParameter("target");
		if (target==null && wizardName.equals("mr") && wizardPage==6){
			errors.add("target", new ActionMessage("object.required"));
		}
		return errors;
	}

	public WizardManager getWizard() {
		return wizard;
	}
	public void setWizard(WizardManager wizard) {
		this.wizard = wizard;
	}
	public String getWizardName() {
		return wizardName;
	}
	public void setWizardName(String wizardName) {
		this.wizardName = wizardName;
	}
	public int getWizardPage() {
		return wizardPage;
	}
	public void setWizardPage(int wizardPage) {
		this.wizardPage = wizardPage;
	}
	public Vector getDomainVector() {
		return domainVector;
	}
	public void setDomainVector(Vector domainVector) {
		this.domainVector = domainVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	
} // end of class
