package cmdbuild.actions;

import java.sql.SQLException;
import java.util.*;

import cmdbuild.action_forms.AttributeForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ErrorBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class AttributeAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward up(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String tabname = ((AttributeForm)form).getClassName();
		String target = ((AttributeForm)form).getTarget(); // hidden tags
        System.out.println("trying up");
        Vector attributeBeanVector = ((AttributeForm)form).getAttributeBeanVector();
		// find target position in vector
		boolean first = false; 
		AttributeBean el=null;
		el = (AttributeBean)attributeBeanVector.firstElement();
		if (el.getName().equals(target)){
			first = true;
		}
		if (first){ // do nothing
			System.out.println("first");
			return mapping.findForward("up");
		} else { // push down
			int vpos=0;
			AttributeBean cb = null;
			for (int i=0;i<=attributeBeanVector.size();i++){
				cb = (AttributeBean)attributeBeanVector.elementAt(i);
				if (cb.getName().equals(target)) { // if found in list
					vpos = i; 
					break;
				}
			}
			AttributeBean t1 = (AttributeBean)attributeBeanVector.elementAt(vpos); // clicked target
			AttributeBean t2 = (AttributeBean)attributeBeanVector.elementAt(vpos-1);
	        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
	        CMDBclass CMDB = new CMDBclass(db);
			try {
				int t1i = t1.getIndex();
				int t2i = t2.getIndex();
				t1.setIndex(t2i); // t1 now has t2.index
				System.out.println("writing t1");
				CMDB.modifyAttribute(tabname,t1.getName(),t1);
				t2.setIndex(t1i); // t2 now has t1.index
				System.out.println("writing t2");
				CMDB.modifyAttribute(tabname,t2.getName(),t2);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			request.getSession().setAttribute("class",tabname);
			// to refresh page
			((AttributeForm)form).reset(mapping,request);
			return mapping.findForward("up");
		}
	}

	public ActionForward down(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String tabname = ((AttributeForm)form).getClassName();
		String target = ((AttributeForm)form).getTarget(); // hidden tags
        System.out.println("trying down");
        Vector attributeBeanVector = ((AttributeForm)form).getAttributeBeanVector();
		// find target position in vector
		boolean first = false; 
		AttributeBean el=null;
		el = (AttributeBean)attributeBeanVector.lastElement();
		if (el.getName().equals(target)){
			first = true;
		}
		if (first){ // do nothing
			System.out.println("last");
			return mapping.findForward("down");
		} else { // push down
			int vpos=0;
			AttributeBean cb = null;
			for (int i=0;i<=attributeBeanVector.size();i++){
				cb = (AttributeBean)attributeBeanVector.elementAt(i);
				if (cb.getName().equals(target)) { // if found in list
					vpos = i; 
					break;
				}
			}
			AttributeBean t1 = (AttributeBean)attributeBeanVector.elementAt(vpos); // clicked target
			AttributeBean t2 = (AttributeBean)attributeBeanVector.elementAt(vpos+1);
	        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
	        CMDBclass CMDB = new CMDBclass(db);
			try {
				int t1i = t1.getIndex();
				int t2i = t2.getIndex();
				t1.setIndex(t2i); // t1 now has t2.index
				System.out.println("writing t1");
				CMDB.modifyAttribute(tabname,t1.getName(),t1);
				t2.setIndex(t1i); // t2 now has t1.index
				System.out.println("writing t2");
				CMDB.modifyAttribute(tabname,t2.getName(),t2);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			request.getSession().setAttribute("class",tabname);
			// to refresh page
			((AttributeForm)form).reset(mapping,request);
			return mapping.findForward("down");
		}
	}

	public ActionForward del(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String tabname = ((AttributeForm)form).getClassName();
		String target = ((AttributeForm)form).getTarget(); // hidden tags - old name
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
        AttributeBean bean = null;
        ErrorBean err = null;
		try {
			bean = CMDB.selectAttributeByName(tabname,target) ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			//e.printStackTrace();
			err = new ErrorBean("attribute.jsp",e);
		}
		boolean empty = false;
		try {
			empty = CMDB.isEmpy(tabname) ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			err = new ErrorBean("attribute.jsp",e);
		}
		System.out.println("trying deletion");
		if (empty){
			try {
				CMDB.deleteAttribute(tabname,target);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				err = new ErrorBean("attribute.jsp",e);
			}
		} else { // not empty, change state
			try {
				if (bean.getType().equals("varchar")){
					bean.setSQLType(bean.getSQLType()+"("+bean.getLength()+")");
				} else {
					bean.setSQLType(bean.getSQLType());
				}
				if (bean.getStatus().equals("active")){ // changing status
					bean.setStatus("noactive");
				} else {
					bean.setStatus("active");
				}
				CMDB.modifyAttribute(tabname,target,bean);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				err = new ErrorBean("attribute.jsp",e);
			}
		}
		request.getSession().setAttribute("class",tabname);
		request.setAttribute("class",tabname);
		if (err==null){
			// to refresh page
			((AttributeForm)form).reset(mapping,request);
			return mapping.findForward("del");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward filter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		// refreshing page
		String superClassFilter = ((AttributeForm)form).getSuperClassFilter();
		System.out.println("in FILTER superClassFilter="+superClassFilter);
		if (superClassFilter != null && superClassFilter.equals("on")){
			request.getSession().setAttribute("superClassAttribute","on");
		} else {
			request.getSession().setAttribute("superClassAttribute","");
		}
		// refreshing page
		((AttributeForm)form).reset(mapping,request);
		return mapping.findForward("filter");
	}
	
} // end of class
