package cmdbuild.actions;

import java.sql.SQLException;

import cmdbuild.action_forms.ClassForm;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class ClassAction extends DispatchAction {

	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**CREATE** action");
		ClassForm f = (ClassForm)form;
		String name = f.getName();
		String description = f.getDescription();
		int idCategory = ( request.getParameter("idCategory")==null? 0 : Integer.parseInt(request.getParameter("idCategory")) );
		String status = f.getStatus();
		String inh = f.getInherits();
		boolean sup = f.isSuperClass();
		String mna = f.getManager();
		//String manager = form.
		ClassBean bean = new ClassBean(name,description,idCategory,status);
		bean.setParent(inh);
		bean.setManager(mna);
		bean.setSuperClass(sup);
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		CMDB = (CMDBclass)CMDB.load(CMDB,mna);
		boolean ok = false;
		ErrorBean err = null;
		try {
			ok = CMDB.createClass(bean);
		} catch (SQLException e){
			err = new ErrorBean("class.jsp",e);
		}
		request.getSession().setAttribute("class",name);
		//request.getSession().setAttribute("mode","show");
		if (ok){
			System.out.println("Tabella creata " + name);
			request.getSession().setAttribute("mode","show");
			f.reset(mapping,request);
			return mapping.findForward("create");
		} else {
			System.out.println("Tabella non creata");
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**MODIFY** action");
		ClassForm f = (ClassForm)form;
		String classname = f.getClassName(); // memorizza stringa class della request
		String newname = request.getParameter("name");	// campo nome della form in class.jsp
		String description = request.getParameter("description");
		String comment = f.getClassBean().getComment();
		String mode = f.getClassBean().getMode(); // class mode: reserved/read/write
		String status = request.getParameter("status");
		int idCategory = 0;
		if (request.getParameter("idCategory")!=null){
			idCategory = Integer.parseInt(request.getParameter("idCategory"));	
		}
		System.out.println("idCategory="+idCategory);
		boolean sup = false;
		String supe = request.getParameter("superClass");
		if (supe!=null && supe.equals("on")){
			sup = true;
		} 
		System.out.println("supe="+supe);
		String man = request.getParameter("manager");
		boolean ok = false;
		ErrorBean err = null;
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		CMDB = (CMDBclass)CMDB.load(CMDB,man);
		if (mode.equals("write")){
			try {
				ClassBean bean = new ClassBean(classname,description,idCategory,status);
				bean.setManager(man);
				bean.setSuperClass(sup);
				ok = CMDB.modifyClass(newname,bean);
			} catch (SQLException e){
				err = new ErrorBean("class.jsp",e);
			}
		} else {
			try {
				String st="";
				if (comment.indexOf("DESCR:")!=-1){
					st = comment.substring(comment.indexOf("DESCR:"));
					if (st.indexOf("|")!=-1){
						st = st.substring(0,st.indexOf("|"));
					} 
					comment = comment.replace(st,"DESCR: "+description);
				} else {
					comment += "|DESCR: "+description;
				}
				ok = CMDB.modifyClassComment(newname,comment);
			} catch (SQLException e){
				err = new ErrorBean("class.jsp",e);
			}
		}
		if (ok){
			System.out.println("Tabella modificata " + classname);
			f.setClassName(newname);
			f.setName(newname);
			// refresh pagina
			request.setAttribute("class",newname);
			request.getSession().setAttribute("class",newname);
			request.getSession().setAttribute("mode","show");
			f.reset(mapping,request);
			return mapping.findForward("modify");
		} else {
			System.out.println("Tabella non modificata");
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}

	public ActionForward delete(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**DELETE** action");
		ClassForm f = (ClassForm)form;
		String classname = f.getClassBean().getName(); // memorizza stringa class della request
		String description = f.getClassBean().getDescription();
		int IdCategory = f.getClassBean().getIdCategory();
		String status = f.getClassBean().getStatus();
		String mna = f.getClassBean().getManager();
		// changing status
		if (status.equals("active")){ 
			status = "noactive";
		} else { // noactive
			status = "active";
		}
		ClassBean bean = new ClassBean(classname,description,IdCategory,status);
		bean.setManager(mna);
		//DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		boolean ok = false;
		ErrorBean err = null;
		boolean empty = false;
		try {
			empty = f.getCMDB().isEmpy(classname) ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			err = new ErrorBean("attribute.jsp",e);
		}
		try {
			if (empty){
				ok = f.getCMDB().deleteClass(classname);
			} else {
				ok = f.getCMDB().modifyClass(classname,bean);
			}
		} catch (SQLException e){
			err = new ErrorBean("class.jsp",e);
		}
		if (ok){
			System.out.println("Tabella modificata " + classname);
			request.getSession().setAttribute("class",null);
			request.getSession().setAttribute("mode","show");
			f.reset(mapping,request);
			return mapping.findForward("delete");
		} else {
			System.out.println("Tabella non modificata");
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**SEARCH** action");
		String search = request.getParameter("search");
		if (search.equals("scegli...")){
			return mapping.findForward("search");
		}
		((ClassForm)form).setClassName(search);
		request.getSession().setAttribute("class",search);
		request.getSession().setAttribute("mode","show");
		((ClassForm)form).reset(mapping,request);
		return mapping.findForward("search");
	}

	public ActionForward loadman(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**LOADMAN** action");
		String manager = request.getParameter("manager");
		((ClassForm)form).setManager(manager);
		//request.getSession().setAttribute("class",search);
		System.out.println("**LOADMAN** action setting mode=create");
		request.getSession().setAttribute("mode","create");
		((ClassForm)form).reset(mapping,request);
		return mapping.findForward("loadman");
	   }
	
} // end of class
