package cmdbuild.actions;


import java.sql.SQLException;

import cmdbuild.action_forms.CreateUserForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBuser;
import cmdbuild.utils.SecurityEncrypter;
import cmdbuild.collection.SecurityBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class CreateUserAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		SecurityBean sb = new SecurityBean();
		String userName = ((CreateUserForm)form).getUserName();
		String description = ((CreateUserForm)form).getDescription();
		String password = ((CreateUserForm)form).getPassword();
		//String confirmPassword = ((CreateUserForm)form).getConfirmPassword();
		int[] role = ((CreateUserForm)form).getGroupId();
		String status = ((CreateUserForm)form).getStatus();
		sb.setUsername(userName);
		sb.setDescription(description);
		// encrypt password
		SecurityEncrypter se = new SecurityEncrypter();
		sb.setPassword(se.encrypt(password));
		if (status.equals("active")){
			sb.setStatus("A");	
		} else {
			sb.setStatus("D");
		}
		// String category = ((CreateTableForm)form).getCategory();
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBuser USER = new CMDBuser(db);
		boolean ok = false;
		try {
			ok = USER.createUser(sb,role);
		} catch (SQLException e){
			e.printStackTrace();
		}
		if (ok){
			//System.out.println("Dominio creato " + name);
			String close="ok";
			request.getSession().setAttribute("close",close);
			return mapping.findForward("create");
		} else {
			System.out.println("Utente non creato");
			return mapping.findForward("error");
		}
	}
} // end of class
