package cmdbuild.actions;

import java.sql.SQLException;
import java.util.*;

import cmdbuild.action_forms.SearchForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBmap;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.FilterBean;
import cmdbuild.collection.InheritsBean;
import cmdbuild.collection.SearchRelationBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class SearchAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */

	public ActionForward filter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**FILTER**");
		Vector attributeVector = ((SearchForm)form).getAttributeBeanVector();
		//Enumeration n = request.getParameterNames();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		Enumeration n =attributeVector.elements();
		String className = ((SearchForm)form).getName();
		Vector selectVector = ((SearchForm)form).getSelectVector();
		Vector filterVector = new Vector(); // contains WHERE conditions of the query
		String target = "";
		String value = "";
		String filterS = "";
		String f_value="";
		AttributeBean atbe = null;
		while (n.hasMoreElements()){
			atbe = (AttributeBean)n.nextElement();
			target = atbe.getName();
			value = request.getParameter(target);
			//System.out.println("SearchAction target="+target+" value="+value);
			if (value!=null && !value.trim().equals("") && !value.equals("&nbsp;")){
				value = value.toUpperCase();
				//System.out.println("u value="+value);
				filterS = "f_"+target;
				f_value = request.getParameter(filterS);
				//System.out.println("CardAction filter="+filterS+" f_value="+f_value);
				if (f_value!=null && f_value.equals(multilanguage.getMessage("com.equal"))){
					filterS = "\""+target+"\"='"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals("=")){
						filterS = "\""+target+"\"='"+value+"'";
						filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals("<")){
					filterS = "\""+target+"\"<'"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(">")){
					filterS = "\""+target+"\">'"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.contains"))){
					filterS = "UPPER(\""+target+"\") LIKE '%"+value+"%'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.startswith"))){
					filterS = "UPPER(\""+target+"\") LIKE '"+value+"%'";
					filterVector.add(filterS);
				}
			}
		}
		Enumeration es = selectVector.elements();
		String reportQuery = "";
		AttributeBean ab = null;
		while(es.hasMoreElements()){
			ab = (AttributeBean)es.nextElement();
			if (reportQuery.equals("")){
				reportQuery = "SELECT \""+ab.getName()+"\"";
			} else {
				reportQuery +=", \""+ab.getName()+"\"";
			}
		}
		reportQuery = reportQuery+" FROM \""+className+"\""; 
		// getting domain filters
		Vector searchRelationVector = ((SearchForm)form).getSearchRelationVector();
	    DBService db = (DBService)servlet.getServletContext().getAttribute("db");
	    CMDBmap MAP = new CMDBmap(db);
	    CMDBclass CMDB = new CMDBclass(db);
		if (searchRelationVector==null){  // patch for back arrow in the browser
			// getting domains associated with this class / used only in filter mode
			Vector domainVector = null;
			Vector assetDomainVector = null;
			InheritsBean supBean = null;
			try {
				domainVector = MAP.selectDomainByClass(className);
				supBean = CMDB.selectSuperClass(className);
				if (!supBean.getParent().equals("class")){
					assetDomainVector = MAP.selectDomainByClass(supBean.getParent());
					assetDomainVector.addAll(domainVector);
					domainVector = assetDomainVector;
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			// creating vector of relations showed in the filter page
			Enumeration en3 = domainVector.elements();
			DomainBean dm = null;
			SearchRelationBean sr = null;
			searchRelationVector = new Vector();
			int i2 = 1;
			boolean addedThisLoop = false;
			while (en3.hasMoreElements()){
				dm = (DomainBean)en3.nextElement();
				addedThisLoop = false;
				if (dm.getStartClass().equals(className) || dm.getStartClass().equals(supBean.getParent())){
					sr = new SearchRelationBean(dm.getDirectDescription(),"dom"+i2,dm.getEndClass(),true);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
					addedThisLoop = true;
				} 
				if (dm.getEndClass().equals(className) || dm.getEndClass().equals(supBean.getParent())){
					if (addedThisLoop == true){
						i2++;
					}
					sr = new SearchRelationBean(dm.getInverseDescription(),"dom"+i2,dm.getStartClass(),false);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
				} 
				i2++;
			}
		}
		Enumeration ens = searchRelationVector.elements();
		String qds = "";
		String doms ="";
		SearchRelationBean srb = null;
		while (ens.hasMoreElements()){
			srb = (SearchRelationBean)ens.nextElement(); 
			target = srb.getInputName(); // dom1, dom2 etc..
			value = request.getParameter(target);
			if (value!=null & !value.equals("")){
				if (request.getSession().getAttribute(target)!=null){
					doms = (String)request.getSession().getAttribute(target);
					if (qds.equals("")){
						if (srb.isDirect()){
							//qds = " WHERE \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" "+doms+")";
							qds = " WHERE \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						} else {
							qds = " WHERE \"Id\" in (select \"IdObj2\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj1\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						}
					} else {
						if (srb.isDirect()){
							qds +=" AND \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						} else {
							qds +=" AND \"Id\" in (select \"IdObj2\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj1\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						}
					}
				}
			}
		}
		reportQuery+=qds;
		//System.out.println("qds is ="+qds);
		if (qds.equals("")){
			reportQuery += " WHERE \"Status\"='A'";
		} else {
			reportQuery += " AND \"Status\"='A'";
		}
		
		// adding where conditions
		Enumeration en = filterVector.elements();
		String sq = "";
		String sqq="";
		while (en.hasMoreElements()){
			sqq = (String)en.nextElement();
			sq+=" AND "+sqq;
		}
		reportQuery = reportQuery + sq;
		// creating query that contains only ids 
		// replacing select parameters with "Id"
		String sq2 = reportQuery.substring(reportQuery.indexOf("FROM"),reportQuery.length());
		String query = "SELECT \"Id\" "+sq2;
		// saved in the session, allow showing of subset of cards
		Hashtable filter = null;
		FilterBean fb = null;
		if (request.getSession().getAttribute("filter")!=null){
			filter = (Hashtable)request.getSession().getAttribute("filter");
			if (filter.containsKey(className)){
				fb = (FilterBean)filter.get(className);
				fb.setQuery(query);
				fb.setReportQuery(reportQuery);
				filter.put(className,fb);
				request.getSession().setAttribute("filter",filter);
				System.out.println("modifing "+className);
			} else {
				fb = new FilterBean();
				fb.setClassName(className);
				fb.setQuery(query);
				fb.setReportQuery(reportQuery);
				filter.put(className,fb);
				request.getSession().setAttribute("filter",filter);
				System.out.println("adding "+className);
			}
		} else {
			filter = new Hashtable();
			fb = new FilterBean();
			fb.setClassName(className);
			fb.setQuery(query);
			fb.setReportQuery(reportQuery);
			filter.put(className,fb);
			request.getSession().setAttribute("filter",filter); 
			System.out.println("creating and adding "+className);
		}
		System.out.println("query="+query+" reportQuery="+reportQuery);
		request.getSession().setAttribute("mode","show");
		// going to page 1
		request.getSession().setAttribute("page",1+"");
		((SearchForm)form).reset(mapping,request);
		return mapping.findForward("filter");
	}
	
	public ActionForward nofilter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**CLEARFILTER**");
		String className = request.getParameter("name");
		// saved in the session, allow showing of subset of cards
		Hashtable filter = null;
		if (request.getSession().getAttribute("filter")!=null){
			filter = (Hashtable)request.getSession().getAttribute("filter");
			if (filter.containsKey(className)){
				System.out.println("Removing "+className);
				filter.remove(className);
				request.getSession().setAttribute("filter",filter);
			}
		}
		((SearchForm)form).setReportVector(null);
		// refreshing page 
		((SearchForm)form).reset(mapping,request);
		return mapping.findForward("filter");
	}
	
	// implements onchange in drop down 
	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**SEARCH**");
		String search = ((SearchForm)form).getSearch();
		System.out.println("Search action="+search);
		((SearchForm)form).setName(search);
		request.getSession().setAttribute("class",search);
		// calling reset method
		((SearchForm)form).reset(mapping,request);
		return mapping.findForward("search");
	   }
	
	public ActionForward display(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		// refreshing page
		System.out.println("**SEARCH**");
		String showAll = ((SearchForm)form).getShowAll();
		if (showAll != null && showAll.equals("on")){
			request.getSession().setAttribute("superClassAttribute","on");
		} else {
			request.getSession().setAttribute("superClassAttribute","");
		}
		System.out.println("showAll is="+showAll);
		// refreshing page
		((SearchForm)form).reset(mapping,request);
		return mapping.findForward("filter");
	}

	
} // end of class
