package cmdbuild.actions;

import cmdbuild.collection.ErrorBean;

import java.io.File;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.struts.action.*;
import org.apache.struts.actions.DispatchAction;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import com.sun.org.apache.xml.internal.serialize.XMLSerializer;

import cmdbuild.action_forms.SetupForm;

public class SetupAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String language = request.getParameter("language");
		String lp;
		boolean languagePrompt; 
		lp = request.getParameter("languagePrompt");
		if (lp!=null && lp.equals("on")){
			languagePrompt = true;
		} else {
			languagePrompt = false;
		}
		String startingClass =  request.getParameter("startingClass");
		String cmdbRealPath = ((SetupForm)form).getCmdbRealPath();
		String path = cmdbRealPath+File.separator+"WEB-INF"+File.separator+"cmdbuild-config.xml";
		File file = new File(path);
		 //Declare variables
		Document document;
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();
		document = builder.parse(file);
		//	Generate the NodeList;
		NodeList nodeList = document.getElementsByTagName("language");
		Element curElm = null;
		// setting language
		nodeList = document.getElementsByTagName("language");
		curElm = (Element)nodeList.item(0);
		curElm.setAttribute("default",language);
		if (languagePrompt){
			curElm.setAttribute("prompt","yes");
		} else {
			curElm.setAttribute("prompt","no");
		}
		nodeList = document.getElementsByTagName("startingclass");
		curElm = (Element)nodeList.item(0);
		curElm.setAttribute("default",startingClass);
		ErrorBean err = null;
		System.out.println("Writing cmdbuild-config......"+path);
		try {
			XMLSerializer serializer = new XMLSerializer();
			serializer.setOutputCharStream(new java.io.FileWriter(path));
			serializer.serialize(document);
	    } catch (Exception ex) {
	    	err = new ErrorBean("setup.jsp",ex);
	    	ex.printStackTrace();
	    }
	    if (err==null){
	        ((SetupForm)form).reset(mapping,request);
			return mapping.findForward("success");
	    } else {
	    	request.getSession().setAttribute("error",err);
			return mapping.findForward("err");
	    }
	}
	
} // end class
