package cmdbuild.collection;

public class AttributeBean {

	private ClassBean classBean = new ClassBean();
    private String name;
    private String SQLType; // type in database
    private String type;    // type used in drop down window (select) in the form
    private int length; 	// used to store varchar length
    private String mandatory;
    private String defaultValue=""; // initialization required
    private String mode;
    private String description;
    private String lookup=""; // initialization required
    private String status;
    private String comment; // necessary for changing comments on columns (Schema)
    private int index;
    private int DBIndex;
    private String baseDSP; // Base Display / show this when seeing cards / values: "true" OR "false" OR ""
    // 
    private String extraInput;

	public AttributeBean() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public AttributeBean(String name, String type, String type2, int length, String mandatory, String description) {
		super();
		// TODO Auto-generated constructor stub
		this.name = name;
		this.SQLType = type;
		this.type = type2;
		this.length = length;
		this.mandatory = mandatory;
		this.description = description;
	}

	public AttributeBean(String name, String type, String type2, int length, String mandatory, String description, String baseDSP) {
		super();
		// TODO Auto-generated constructor stub
		this.name = name;
		this.SQLType = type;
		this.type = type2;
		this.length = length;
		this.mandatory = mandatory;
		this.description = description;
		this.baseDSP = baseDSP;
	}
	
	
	/***********************/
	/* GETTERS AND SETTERS */
	/***********************/

	public String getDefaultValue() {
		return defaultValue;
	}
	public void setDefaultValue(String default1) {
		int s,e;
		if (default1!=null) {
			if (default1.indexOf("'") != -1) { // type lookup is modified when calling setALookup
				s = default1.indexOf("'");  // 'ciao'::character varying
				e = default1.lastIndexOf("'");
				if ((s!=-1) && (e!=-1)){
					defaultValue = default1.substring(s+1,e);
				}
			} else {
				defaultValue = default1;
			}
		} else { // is null
			defaultValue = default1;
		}
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getLookup() {
		return lookup;
	}
	public void setLookup(String lookup) { 
		if ( (lookup==null) || lookup.trim().equals("") ){
			this.lookup = lookup;
		} else {
			this.lookup = lookup;
			this.type = "lookup";	// now aType is lookup, before was a varchar
		}
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getIndex() {
		return index;
	}
	public void setIndex(int index) {
		this.index = index;
	}
	public int getDBIndex() {
		return DBIndex;
	}
	public void setDBIndex(int index) {
		DBIndex = index;
	}
	public String getMandatory() {
		return mandatory;
	}
	public void setMandatory(String mandatory) {
		String m = "";
		m = mandatory;
		if (m!=null){ 
			if (m.equals("")){
				this.mandatory= "N";
			} else if (m.indexOf("NOT NULL")!=-1){
				this.mandatory = "Y";
			} else if (m.equals("Y")){
				this.mandatory = "Y";
			} else {
				this.mandatory= "N";
			}
		} else {
			this.mandatory = mandatory;
		}
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		if ((status==null) || (status.equals(""))){
			this.status = "active";
		} else {
			this.status = status;
		}
	}
	public String getSQLType() {
		return SQLType;
	}
	public void setSQLType(String type) {
		SQLType = type;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) { //transform SQLtype in aType
		int s,e;
		//System.out.println("type in AttributeBean="+type);
		if (type!=null && type.indexOf("numeric") != -1) {
			this.type = "numeric";
			s = type.indexOf("(");
			e = type.indexOf(")");
			if ((s!=-1) && (e!=-1)){
				extraInput = type.substring(s,e);
			}
		} else if (type!=null && type.indexOf("varchar") != -1) { // type lookup is modified when calling setALookup
			this.type = "varchar";
			s = type.indexOf("(");
			e = type.indexOf(")");
			if ((s!=-1) && (e!=-1)){
				extraInput = type.substring(s,e);
				this.length= Integer.parseInt(extraInput);
			}
		} else if (type!=null && type.indexOf("char") != -1){ // bpchar
			this.type = "varchar";
		} else if (type!=null && type.indexOf("int") != -1) {
			this.type = "int4";
		} else if (type!=null && type.indexOf("float") != -1) {
			this.type = "float8";
		} else {
			this.type = type;
		}
	}
	public int getLength() {
		return length;
	}
	public void setLength(int length) {
		this.length = length;
	}
	public String getExtraInput() {
		return extraInput;
	}
	public void setExtraInput(String extraInput) {
		this.extraInput = extraInput;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getBaseDSP() {
		return baseDSP;
	}
	public void setBaseDSP(String baseDSP) {
		if (baseDSP==null){
			this.baseDSP = "";
		} else {
			this.baseDSP = baseDSP;
		}
	}
	public String getComment() {
		return comment;
	}
	public void setComment(String comment) {
		this.comment = comment;
	}
	public ClassBean getClassBean() {
		return classBean;
	}
	public void setClassBean(ClassBean classBean) {
		this.classBean = classBean;
	}

} // end of class
