package cmdbuild.presentation;

import cmdbuild.collection.AssetBean;
import cmdbuild.collection.LookupBean;

import java.util.Enumeration;
import java.util.Vector;

public class BaseDisplay implements HTMLInterface{
	
	private Vector assetVector;
	private Vector lookupVector;
	private String HTMLtext;
	private boolean deleted = false;

	public BaseDisplay() {
		super();
		// TODO Auto-generated constructor stub
	}

	public BaseDisplay(Vector assetVector, Vector lookupVector) {
		super();
		// TODO Auto-generated constructor stub
		this.assetVector = assetVector;
		this.lookupVector = lookupVector;
	}

	public BaseDisplay(Vector assetVector, Vector lookupVector, boolean deleted) {
		super();
		// TODO Auto-generated constructor stub
		this.assetVector = assetVector;
		this.lookupVector = lookupVector;
		this.deleted = deleted;
	}

	// generate the code for BaseDSP table
	public String toForm(){
		String HTMLtext = "";
		if (assetVector==null){
			return HTMLtext;
		}
		HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (obj.getBaseDSP().equals("true")){ 
				//System.out.println(obj.getName()+" is type in asset="+obj.getType());
				if (obj.getType().equals("lookup")){
					HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td>";
					Enumeration en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (obj.getValue()!=null){
							String id = ""+lb.getId(); 
							//System.out.println("obj is "+obj.getValue().getClass().getName());
							if (id.equals(obj.getValue())){
								HTMLtext+=lb.getDescription();
								break;
							}
						} else {
							HTMLtext+="&nbsp;";
						}
					}
					HTMLtext+="</td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getValue()!=null && obj.getType().equals("bool")){
					if (obj.getValue().equals("t") || obj.getValue().equals("true")){
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>S</td></tr>\n";	
					} else { // f || false
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>N</td></tr>\n";
					}
				} else {
					if (obj.getValue()==null || obj.getValue().equals("")){ 
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>&nbsp;</td></tr>\n";					
					} else {
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>"+obj.getValue()+"</td></tr>\n";					
					}
				}
			}
		}
		HTMLtext+="</table>\n";
		return HTMLtext;
	}

	public Vector getAssetVector() {
		return assetVector;
	}
	public void setAssetVector(Vector assetVector) {
		this.assetVector = assetVector;
	}
	public boolean isDeleted() {
		return deleted;
	}
	public void setDeleted(boolean deleted) {
		this.deleted = deleted;
	}
	public String getHTMLtext() {
		return HTMLtext;
	}
	public void setHTMLtext(String ltext) {
		HTMLtext = ltext;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	

} // end of class
