package cmdbuild.utils;

import cmdbuild.collection.SecurityBean;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class SecurityDescriptor {

	private int id;
	private String userName;
	//private String password;
	private String description;
	private boolean administrator;
	private boolean fullOperator=false; // if sb.getClassId()==0 
	private SecurityBean fullOperatorBean; // used only for full operator 
	private Hashtable permission = new Hashtable();
	private Vector permitVector;
	
	public SecurityDescriptor() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public SecurityDescriptor(String userName, String description, boolean administrator) {
		super();
		// TODO Auto-generated constructor stub
		this.userName = userName;
		this.description = description;
		this.administrator = administrator;
	}

	public SecurityDescriptor(String userName, String description, boolean administrator, Vector permitVector) { // Vector SecurityBean
		super();
		// TODO Auto-generated constructor stub
		this.userName = userName;
		this.description = description;
		this.administrator = administrator;
		SecurityBean sb = null;
		if (permitVector!=null && !administrator){
			Enumeration en = permitVector.elements();
			while (en.hasMoreElements()){
				sb = (SecurityBean)en.nextElement();
				if (sb.getClassId()==0){
					fullOperator=true;
					fullOperatorBean = sb;
					break;
				}
				// memorized by ClassName and ClassId
				if (sb.getClassId()!=0 && !permission.containsKey(sb.getClassName())){
					permission.put(sb.getClassName(),sb);
				}
				if (sb.getClassId()!=0 && !permission.containsKey(sb.getClassId()+"")){
					permission.put(sb.getClassId()+"",sb);
				}
			}
		}
	}

	public boolean isAllowed(String className, int level) {
		SecurityBean sb = null;
		if (administrator){
			return true;
		}
		if (fullOperator){
			sb = fullOperatorBean;
			if (sb.getLevel()>=level){
				return true;
			} else {
				return false;
			}
		}
		if (permission.containsKey(className)){
			sb = (SecurityBean)permission.get(className);
			if (sb.getLevel()>=level){
				return true;
			} else {
				return false;
			}
		}
		return false;
	}
	public boolean isAllowed(int classId, int level) {
		SecurityBean sb = null;
		if (administrator){
			return true;
		}
		if (fullOperator){
			sb = fullOperatorBean;
			if (sb.getLevel()>=level){
				return true;
			} else {
				return false;
			}
		}
		if (permission.containsKey(classId+"")){
			sb = (SecurityBean)permission.get(classId+"");
			if (sb.getLevel()>=level){
				return true;
			} else {
				return false;
			}
		}
		return false;
	}
	
	
	public void setPermitVector(Vector permitVector) {
		this.permitVector = permitVector;
		SecurityBean sb = null;
		// resetting permission
		permission = new Hashtable();
		if (permitVector!=null && !administrator){
			Enumeration en = permitVector.elements();
			while (en.hasMoreElements()){
				sb = (SecurityBean)en.nextElement();
				System.out.println("set permitvector "+sb.getClassId());
				if (sb.getClassId()==0){
					fullOperator=true;
					fullOperatorBean = sb;
					break;
				}
				System.out.println("fullOp= "+fullOperator);
				// memorized by ClassName and ClassId
				if (sb.getClassId()!=0 && !permission.containsKey(sb.getClassName())){
					permission.put(sb.getClassName(),sb);
				}
				if (sb.getClassId()!=0 && !permission.containsKey(sb.getClassId()+"")){
					permission.put(sb.getClassId()+"",sb);
				}
			}
		}
	}
	public Vector getPermitVector() {
		return permitVector;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public Hashtable getPermission() {
		return permission;
	}
	public void setPermission(Hashtable permission) {
		this.permission = permission;
	}
	public String getUserName() {
		return userName;
	}
	public void setUserName(String userName) {
		this.userName = userName;
	}
	public boolean isAdministrator() {
		return administrator;
	}
	public void setAdministrator(boolean administrator) {
		this.administrator = administrator;
	}
	public boolean isFullOperator() {
		return fullOperator;
	}
	public void setFullOperator(boolean fullOperator) {
		this.fullOperator = fullOperator;
		System.out.println("setting fullOp="+fullOperator);
	}
	
	
} // end of class
