package cmdbuild.utils;

import java.io.File;
import java.util.Collection;
import java.util.LinkedList;

import javax.xml.parsers.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


public class Settings {

	private Collection managersList;
	private String cmdbRealPath;
	private String language ="";
	private boolean languagePrompt;
	private String startingClass="";
	
	public Settings() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Settings(String url) {
		super();
		// TODO Auto-generated constructor stub
		managersList = new LinkedList();
		try {
			System.out.println("** CMDB SETTINGS **");
			this.cmdbRealPath = url;
			String path = url+File.separator+"WEB-INF"+File.separator+"cmdbuild-config.xml";
			System.out.println("Loading cmdbuild-config......"+path);
			File file = new File(path);
			 //Declare variables
			Document document;
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			document = builder.parse(file);
			//	Generate the NodeList;
			NodeList nodeList = document.getElementsByTagName("manager");
			Element curElm = null;
			for (int i=0; i<nodeList.getLength(); i++){
				//Node curNode = nodeList.item(i);
				//	Get name:
				curElm = (Element)nodeList.item(i);
				String cur = curElm.getAttribute("name");
				//System.out.println("ManagerList cur="+cur);
				managersList.add(cur);
			}//end for
			nodeList = document.getElementsByTagName("language");
			curElm = (Element)nodeList.item(0);
			language = curElm.getAttribute("default");
			String lp = curElm.getAttribute("prompt");
			if (lp.length()>0 && lp.indexOf("n")!=-1){
				languagePrompt = false;
			} else {
				languagePrompt = true;
			}
			nodeList = document.getElementsByTagName("startingclass");
			curElm = (Element)nodeList.item(0);
			startingClass = curElm.getAttribute("default");
			if (startingClass==null){
				startingClass = "";
			}
			//System.out.println("Startingclass="+startingClass);
		} catch (Exception e){
			e.printStackTrace();
		}		
	}

	public String getLanguage() {
		return language;
	}
	public void setLanguage(String language) {
		this.language = language;
	}
	public boolean isLanguagePrompt() {
		return languagePrompt;
	}
	public void setLanguagePrompt(boolean languagePrompt) {
		this.languagePrompt = languagePrompt;
	}
	public Collection getManagersList() {
		return managersList;
	}
	public void setManagersList(Collection managersList) {
		this.managersList = managersList;
	}
	public String getStartingClass() {
		return startingClass;
	}
	public void setStartingClass(String startingClass) {
		this.startingClass = startingClass;
	}
	public String getCmdbRealPath() {
		return cmdbRealPath;
	}
	public void setCmdbRealPath(String cmdbRealPath) {
		this.cmdbRealPath = cmdbRealPath;
	}
	

} // end of class
