package cmdbuild.wizards;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.upload.FormFile;

import cmdbuild.action_forms.ImportForm;
import cmdbuild.collection.AssetBean;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.LookupBean;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.wizards.importutils.CSVReader;
import cmdbuild.wizards.importutils.ImportLine;
import cmdbuild.wizards.importutils.ImportTable;

public class Import extends WizardTemplate {

	private CMDBclass CMDB;
	private CMDBlookup LOOKUP;
	private Collection classCollection;
	private FormFile theFile;
	private Vector attributeVector;
	private Vector lookupVector;
	private Hashtable lookupHash;
	private CSVReader csv;
	private ImportTable it;
	
	public Import() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public Import(DBService db, MultiLanguage multilanguage) {
		super();
		// TODO Auto-generated constructor stub
		this.db = db;
		this.multilanguage = multilanguage;
	}
	
	public String toForm(int page){
		String HTMLtext = "";
		switch (page) {
           	case 1:  HTMLtext = toPage1(); break;
           	case 2:  HTMLtext = toPage2(); break;
           	case 3:  HTMLtext = toPage3(); break;
		}
		if (HTMLtext.equals("")){
			HTMLtext = toLastPage();
		}
		return HTMLtext;
	}
	
	public void getDataForPage(HttpServletRequest request, int page){
		switch (page) {
           	case 1:  getPage1(request); break;
           	case 2:  getPage2(request); break;
           	case 3:  getPage3(request); break;
		}
	}
	
	public void actionForPage(HttpServletRequest request, int page){
		switch (page) {
           	case 1:  actionPage1(request); break;
           	case 2:  actionPage2(request); break;
           	case 3:  actionPage3(request); break;
		}
	}

	// page 1
	public void getPage1(HttpServletRequest request){
		CMDB = new CMDBclass(db);
		if (classCollection==null){
			classCollection = new LinkedList();
			try {
				Collection coll = CMDB.selectAllClass();
				if (coll==null){
					coll = new LinkedList();
				}
				Iterator iter = coll.iterator();
				ClassBean cb = null;
				while(iter.hasNext()){
					cb = (ClassBean) iter.next();
					// show only if user has permission or not superclass
					if (!cb.isSuperClass() && user.isAllowed(cb.getName(),2)){
						classCollection.add(cb);
					}
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	public String toPage1(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 1</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("import.hello1")+"</td></tr>";
		HTMLtext += "\t<tr><td><select name=\"importselect\">";
		Iterator iter = classCollection.iterator();
		ClassBean cb = null;
		String savedc = "";
		if (choice.get("page1")!=null){
			savedc = (String) choice.get("page1");
		}
		while (iter.hasNext()){
			cb = (ClassBean) iter.next();
			if (!savedc.equals(cb.getName())){
				HTMLtext += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";	
			} else {
				HTMLtext += "<option value=\""+cb.getName()+"\" selected>"+cb.getDescription()+"</option>";
			}
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" disabled value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"importForm.method.value='back';submit();\">";
		HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\"importForm.method.value='next';submit();\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage1(HttpServletRequest request){
		String str = request.getParameter("importselect");
		choice.put("page1",str);
		String className = (String) choice.get("page1");
		if (CMDB==null){
			CMDB = new CMDBclass(db);
		}
		if (LOOKUP==null){
			LOOKUP = new CMDBlookup(db);
		}
		try {
			attributeVector = CMDB.selectAllAttribute(className,"rw");
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		lookupVector = new Vector();
		Vector options= null;
		AttributeBean as = null;
		Enumeration enu = null;
		if (attributeVector!=null){
			enu = attributeVector.elements();
			Hashtable hash = new Hashtable();
			while (enu.hasMoreElements()){
				as = (AttributeBean)enu.nextElement();
				if (as.getType().equals("lookup")){
					try {
						if (!hash.containsKey(as.getLookup())){ // don't get duplicates
							System.out.println("Getting lookup for "+as.getLookup());
							options = LOOKUP.selectLookupByType(as.getLookup());
							hash.put(as.getLookup(),as.getLookup());
						}
						//System.out.println("options.size="+options.size());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					if (options!=null){
						lookupVector.addAll(options);
					}
				}
			}
			if (lookupHash==null){
				lookupHash = new Hashtable();	
			}
			enu = lookupVector.elements();
			LookupBean lb = null;
			while (enu.hasMoreElements()){
				lb = (LookupBean)enu.nextElement();
				if (!lookupHash.containsKey(lb.getDescription())){
					lookupHash.put(lb.getDescription(),lb);
				}
			}
		}
	}
	
	// page 2
	public void getPage2(HttpServletRequest request){
	}
	public String toPage2(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 2</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("import.hello2")+":</td></tr>";
		HTMLtext += "\t<tr><td><input type=\"file\" name=\"theFile\"></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("import.hello3")+":</td></tr>";
		HTMLtext += "\t<tr><td><input type=\"radio\" name=\"separator\" value=\",\" checked><b>,</b><input type=\"radio\" name=\"separator\" value=\"|\"><b>|</b></td></tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"importForm.method.value='back';submit();\">";
		HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\"javascript:if (testFile()){importForm.method.value='next';submit();}else{alert('"+multilanguage.getMessage("import.hello2")+"');}\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage2(HttpServletRequest request){
		ImportForm form = (ImportForm)request.getAttribute("importForm");
		if (form!=null){
			theFile = form.getTheFile();	
			System.out.println(theFile.getFileName());
			System.out.println(theFile.getContentType());
			System.out.println(theFile.getFileSize());
		} else {
			System.out.println("no form!");
		}
		String separator = request.getParameter("separator");
		try {
			if (separator!=null){
				csv = new CSVReader(theFile.getInputStream(),separator.charAt(0));	
			} else {
				csv = new CSVReader(theFile.getInputStream());
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// clearing previous ImportTable 
		request.getSession().setAttribute("importTable",null);
	}
	
	// page 3
	public void getPage3(HttpServletRequest request){
		if (request.getSession().getAttribute("importTable")!=null){ // if it's in session then it was stored by ImportPopup
			it = (ImportTable) request.getSession().getAttribute("importTable");
		} else {
			it = new ImportTable(csv.getHeader(),csv.getTableVector(),attributeVector,lookupHash);
		}
		request.getSession().setAttribute("importTable",it);
	}
	public String toPage3(){
		String HTMLtext = "";
		if (it.isImportOk()){
			HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
			HTMLtext +=	multilanguage.getMessage("com.page")+" 3</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		} else {
			HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
			String button = "<a href=\"javascript:void(0)\" onclick=\"window.open('importpopup.jsp?class="+choice.get("page1")+"',null,'height=600,width=800,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_edit.gif\" alt=\"modifica\" title=\"modifica\"></a>";
			HTMLtext +=	multilanguage.getMessage("com.page")+" 3 "+button+"</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		}
		// creating lookup hash
		AssetBean as = null;
    	HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
		// creating header of the table
		Enumeration en = it.getHeaderVector().elements();
		while (en.hasMoreElements()){
			as = (AssetBean)en.nextElement();
			if (!as.isToDelete()){
				HTMLtext+="<th>"+as.getValue()+"</th>";
			} else {
				HTMLtext+="<th style=\"color:red\">"+as.getValue()+"</th>";
			}
 		}
 		HTMLtext+="\n";
 		// creating the table
 		String value="";
 		Enumeration enr = it.getLinesVector().elements();
 		ImportLine il = null;
 		int nlines = 0;
 		int ncolumns = 0;
 		while (enr.hasMoreElements()){
 			nlines++;
			il = (ImportLine) enr.nextElement();
			if (il.getLineVector()==null){
				System.out.println("lineVector is null!!");
			}
			if (il.getLineVector().size()==it.getHeaderVector().size()){ // right number of columns
	 			Enumeration eni = il.getLineVector().elements();
	 			ncolumns = 0;
				HTMLtext+="<tr>";
				while(eni.hasMoreElements()){
					ncolumns++;
					as = (AssetBean)eni.nextElement();
					value = as.getValue();
					if (value==null || value.equals("")){
						HTMLtext+="<td>&nbsp;</td>";
					} else if(as.isToDelete()){
						HTMLtext+="<td style=\"color:red\">"+value+"</td>";
					} else {
						HTMLtext+="<td>"+value+"</td>";
					}
				}
				HTMLtext+="</tr>\n";
			} else { // // erroneus number of columns
	 			Enumeration eni = il.getLineVector().elements();
	 			ncolumns = 0;
				HTMLtext+="<tr style=\"color:red\"><td colspan=\""+it.getHeaderVector().size()+"\">";
				while(eni.hasMoreElements()){
					ncolumns++;
					as = (AssetBean)eni.nextElement();
					value = as.getValue();
					if (value==null || value.equals("")){
						HTMLtext+=" &nbsp;";
					} else {
						HTMLtext+=" "+value;
					}
				}
				HTMLtext+="</td></tr>\n";	
			}
		}	
		HTMLtext+="</table>\n";
		HTMLtext += "\t<table><tr>";
 		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"method.value='back';submit();\">";
 		if (it.isImportOk()){
 			HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.confirm")+"\" class=\"button\" onclick=\"method.value='next';submit();\">";	
 		} else {
 			HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.confirm")+"\" class=\"button\" onclick=\"alert('"+multilanguage.getMessage("import.notvalid")+"');\">";
 		}
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n</table>\n";
		HTMLtext += "<input type=\"hidden\" name=\"importok\" value=\""+it.isImportOk()+"\">";
		return HTMLtext;
	}
	public void actionPage3(HttpServletRequest request){
		String className = (String) choice.get("page1");
		// adding IdClass
		Iterator iter = classCollection.iterator();
		ClassBean cb = null;
		while (iter.hasNext()){
			cb = (ClassBean) iter.next();
			if (cb.getName().equals(className)){
				break;
			}
		}
		AssetBean idclass = new AssetBean();
		idclass.setName("IdClass");
		idclass.setType("integer");
		idclass.setValue(cb.getId()+"");
		AssetBean status = new AssetBean();
		status.setName("Status");
		status.setType("varchar");
		status.setValue("A");
		Vector tableVector = new Vector();
		Vector columnVector = null;
		ImportLine il = null;
		Enumeration en = it.getLinesVector().elements();
		Enumeration eni = null;
		AssetBean as = null;
		LookupBean lb = null;
		String val = "";
		boolean thereisidclass = false;
		while (en.hasMoreElements()){
			il = (ImportLine) en.nextElement();
			columnVector = il.getLineVector();
			eni = columnVector.elements();
			thereisidclass = false;
			while (eni.hasMoreElements()){
				as = (AssetBean) eni.nextElement();
				if (as.getName().equals("IdClass")){
					thereisidclass=true;
				}
				// replacing lookup description with lokkup id
				if (as.getType().equals("lookup") && !as.isToDelete()){
					val = as.getValue();
					lb = (LookupBean) lookupHash.get(val);
					as.setValue(lb.getId()+"");
				}
			}
			if (!thereisidclass){
				columnVector.add(idclass);
			}
			columnVector.add(status);
			tableVector.add(columnVector);
		}
		ErrorBean err = null;
		try {
			CMDB.createCardBatch(className,tableVector,user.getUserName());
		} catch (SQLException e) {
			err = new ErrorBean("import.jsp",e);
		}
		request.getSession().setAttribute("error",err);
	}

	public String toLastPage(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("wizard.result")+"</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("wizard.final")+"</td></tr>";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	
	public FormFile getTheFile() {
		return theFile;
	}
	public void setTheFile(FormFile theFile) {
		this.theFile = theFile;
	}
	
} // end of class
