package cmdbuild.wizards;

import cmdbuild.collection.AssetBean;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.FilterBean;
import cmdbuild.collection.InheritsBean;
import cmdbuild.collection.LookupBean;
import cmdbuild.collection.SearchRelationBean;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;
import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.IdBean;

import java.sql.SQLException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;

public class WizardMR extends WizardTemplate {

	
	// from modifyrelation
	private Vector domainVector;
	private DomainBean currentDomain;
	private boolean direct;
	private Collection classCollection;
	private boolean showAll = false;
	private Vector rowIdVector;
	private Vector attributeVector1;
	private Vector attributeVector2;
	private Vector selectVector1;
	private Vector selectVector2;
	private Vector lookupVector1;
	private Vector lookupVector2;
	private Vector treeVector;
	private String formName = "wizardForm";
	private Vector searchRelationVector;
	private Hashtable lookupHash;
	private Vector reportVector;
	private int resultsForPage;
	private int subpage;
	private int totalPages;
	// temp
	private Hashtable namedesc;
	private CMDBmap MAP;
	private CMDBclass CMDB;
	private CMDBlookup LOOKUP;
	
	public WizardMR() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public String toForm(int page){
		String HTMLtext = "";
		switch (page) {
           	case 2:  HTMLtext = toPage2(); break;
           	case 3:  HTMLtext = toPage3(); break;
           	case 4:  HTMLtext = toPage4(); break;
           	case 5:  HTMLtext = toPage5(); break;
           	case 6:  HTMLtext = toPage6(); break;
		}
		return HTMLtext;
	}
	
	public void getDataForPage(HttpServletRequest request, int page){
		switch (page) {
           	case 2:  getPage2(request); break;
           	case 3:  getPage3(request); break;
           	case 4:  getPage4(request); break;
           	case 5:  getPage5(request); break;
           	case 6:  getPage6(request); break;
		}
	}
	
	public void actionForPage(HttpServletRequest request, int page){
		switch (page) {
           	case 2:  actionPage2(request); break;
           	case 3:  actionPage3(request); break;
           	case 4:  actionPage4(request); break;
           	case 5:  actionPage5(request); break;
           	case 6:  actionPage6(request); break;
		}
	}

	// page 2
	public void getPage2(HttpServletRequest request){
		MAP = new CMDBmap(db);
		try {
			domainVector = MAP.selectAllDomain();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		CMDB = new CMDBclass(db);
		try {
			treeVector = CMDB.selectClassTree();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		namedesc = new Hashtable();
		Enumeration en = treeVector.elements();
		InheritsBean ih = null;
		while (en.hasMoreElements()){
			ih = (InheritsBean) en.nextElement();
			if (!namedesc.containsKey(ih.getChild())){
				namedesc.put(ih.getChild(),ih.getChildDescription());
			}
			if (!namedesc.containsKey(ih.getParent())){
				namedesc.put(ih.getParent(),ih.getParentDescription());
			}
		}
	}
	public String toPage2(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 2</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("wizard.selectrelation")+"</td></tr>";
		HTMLtext += "\t<tr><td><select name=\"relationselect\">";
		Enumeration en = domainVector.elements();
		DomainBean dm = null;
		String txt = "";
		String relsel = "";
		if (choice.get("page2")!=null){
			relsel = (String) choice.get("page2");
		}
		while (en.hasMoreElements()){
			dm = (DomainBean)en.nextElement();
			txt = namedesc.get(dm.getStartClass())+" "+dm.getDirectDescription()+" "+namedesc.get(dm.getEndClass())+" | "+namedesc.get(dm.getEndClass())+" "+dm.getInverseDescription()+" "+namedesc.get(dm.getStartClass());
			if (txt.length()>70){
				txt = txt.substring(0,70)+"...";
			}
			if (!dm.getName().equals(relsel)){
				HTMLtext += "<option value=\""+dm.getName()+"\">"+txt+"</option>";	
			} else {
				HTMLtext += "<option value=\""+dm.getName()+"\" selected>"+txt+"</option>";
			}
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"method.value='back';submit();\">";
		HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\"method.value='next';submit();\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage2(HttpServletRequest request){
		String relsel = request.getParameter("relationselect");
		choice.put("page2",relsel);
	}
	
	// page 3
	public void getPage3(HttpServletRequest request){
		// calculating classCollection
		classCollection = new LinkedList();
		/*
		// patches search action
		if (CMDB==null){
			getPage2(request);
		}
		try {
			vett = CMDB.selectClassTree();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		*/
		Enumeration en = domainVector.elements();
		DomainBean dm = null;
		while (en.hasMoreElements()){
			dm = (DomainBean)en.nextElement();
			if (dm.getName().equals(choice.get("page2"))){
				//System.out.println("found dm");
				currentDomain = dm;
				break;
			}
		}
		InheritsBean inh = null;
		HashSet result = new HashSet();
		HashSet target = new HashSet();
		result.add(dm.getStartClass());
		result.add(dm.getEndClass());
		target.add(dm.getStartClass());
		target.add(dm.getEndClass());
		String tar = "";
		while (!target.isEmpty()){
			tar = (String)target.toArray()[0];
			en = treeVector.elements();
			while (en.hasMoreElements()){
				inh = (InheritsBean) en.nextElement();
				if (inh.getParent().equals(tar)){
					target.add(inh.getChild());
				}
			}
			result.add(tar);
			target.remove(tar);
		}
		ClassBean cb = null;
		Iterator it = result.iterator();
		
		while (it.hasNext()){
			tar = (String) it.next();
			cb = new ClassBean();
			cb.setName(tar);
			cb.setDescription((String)namedesc.get(tar));
			classCollection.add(cb);
		}
		String name  = "";
		if (choice.containsKey("startClass")){
			name = (String)choice.get("startClass");
		} else {
			name = ((ClassBean) classCollection.toArray()[0]).getName();
		}
	    if (CMDB.getBean()==null){
	    	try {
				CMDB.setBean(CMDB.selectClassByName(name));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		System.out.println("classe="+name);
		// creating a select vector, contains elements to retrieve for the query select...
		try {
			attributeVector1 = CMDB.selectAllAttribute(name,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// save this attributeVector
		// creating selectVector
		Vector vec = new Vector();
		selectVector1 = new Vector();
		AttributeBean id = new AttributeBean();
		id.setName("Id");
		id.setSQLType("int4");
		id.setType("int4");
		vec.add(id);
		id = new AttributeBean();
		id.setName("IdClass");
		id.setSQLType("int4");
		id.setType("int4");
		vec.add(id);
		vec.addAll(selectVector1);
		selectVector1 = vec;
		Enumeration en2 = attributeVector1.elements();
		AttributeBean ab = null;
		while (en2.hasMoreElements()){
			ab = (AttributeBean)en2.nextElement();
			if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
				if (ab.getBaseDSP().equals("true")){
 					selectVector1.add(ab);
				}
			}
		}
		LOOKUP = new CMDBlookup(db);
		CMDBmap MAP = new CMDBmap(db);
        AttributeBean at = null;
		// creating lookupVector if there are lookups
		Enumeration enu = attributeVector1.elements();
		lookupVector1 = new Vector();
		Vector options= null;
		Hashtable hash = new Hashtable();
		while (enu.hasMoreElements()){
			at = (AttributeBean) enu.nextElement();
			if (at.getType().equals("lookup")){
				try {
					if (!hash.containsKey(at.getLookup())){ // don't get duplicates
						System.out.println("Getting lookup for "+at.getLookup());
						options = LOOKUP.selectLookupByType(at.getLookup());
						hash.put(at.getLookup(),at.getLookup());
					}
					//System.out.println("options.size="+options.size());
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if (options!=null){
					lookupVector1.addAll(options);
				}
			}
		}
		// creating a tree of this class       
        Hashtable pt = new Hashtable();  // key = child   value = parent
        Vector ptv = null;
        try {
			ptv = CMDB.selectClassTree();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
        en = ptv.elements();
        inh = null;
		while (en.hasMoreElements()){
			inh = (InheritsBean)en.nextElement();
			pt.put(inh.getChild(),inh.getParent());
		}
		String targ = name;
		HashSet ptset = new HashSet();
		while (pt.containsKey(targ)){
			ptset.add(targ);
			targ = (String)pt.get(targ);
		}
		dm = null;
		domainVector = new Vector();
		try {
			domainVector = MAP.selectAllDomain();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		// creating vector of relations showed in the filter page
		Enumeration en3 = domainVector.elements();
		SearchRelationBean sr = null;
		searchRelationVector = new Vector();
		int i2 = 1;
		boolean addedThisLoop = false;
		while (en3.hasMoreElements()){
			dm = (DomainBean)en3.nextElement();
			addedThisLoop = false;
			if (ptset.contains(dm.getStartClass())){
				sr = new SearchRelationBean(dm.getDirectDescription(),"dom"+i2,dm.getEndClass(),true);
				sr.setDomainRealName(dm.getName());
				searchRelationVector.add(sr);
				addedThisLoop = true;
			} 
			if (ptset.contains(dm.getEndClass())){
				if (addedThisLoop == true){
					i2++;
				}
				sr = new SearchRelationBean(dm.getInverseDescription(),"dom"+i2,dm.getStartClass(),false);
				sr.setDomainRealName(dm.getName());
				searchRelationVector.add(sr);
			} 
			i2++;
		}
	}
	public String toPage3(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 3</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr30\">classe</td>";
		HTMLtext+="<td><select name=\"f_className\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
		HTMLtext+="<td><select name=\"search\" onchange=\"method.value='search';submit()\">";
		Iterator it = classCollection.iterator();
		String thisname ="";
		if (choice.get("startClass")!=null){
			thisname = (String)choice.get("startClass");
		}
		while (it.hasNext()){
			ClassBean cb = (ClassBean)it.next();
			if (!thisname.equals(cb.getName())){
				HTMLtext+="<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";	
			} else {
				HTMLtext+="<option value=\""+cb.getName()+"\" selected>"+cb.getDescription()+"</option>";
			}
		}
		HTMLtext+="</select>";
		HTMLtext+="</td></tr>\n";
		if (user.isAllowed(thisname,1)){
			HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
			// showing only baseDSPs, removing the others
			AttributeBean toer = null;
			if (!showAll && attributeVector1!=null && attributeVector1.size()>0){
				for (int i=attributeVector1.size()-1;i>=0;i--){
					toer = (AttributeBean) attributeVector1.elementAt(i);
					if (!toer.getBaseDSP().equals("true")){
						attributeVector1.remove(i);
					}
				}
			}
			Enumeration e = attributeVector1.elements();
			AttributeBean obj = null;
			while (e.hasMoreElements()){
				obj = (AttributeBean)e.nextElement();
				if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
					//System.out.println(obj.getAName()+" in asset="+obj.getAType());
					if (obj.getType().equals("lookup")){
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
						HTMLtext+="<td><select name=\""+obj.getName()+"\">";
						// adding "" option
						HTMLtext+="<option></option>";
						Enumeration en = lookupVector1.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
							if (lb.getType().equals(obj.getLookup())){
								HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
							}
						}
						HTMLtext+="</select></td>";
						HTMLtext+="</tr>\n";
					} else if( obj.getType().equals("varchar") ){
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" onkeypress=\"doSearch(event)\"></td></tr>\n";
					} else if( obj.getType().equals("text") ){
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
						HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\" onkeypress=\"doSearch(event)\"></textarea></td></tr>\n";
					} else if( obj.getType().equals("date") ){ 
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
						HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td></tr>\n";
					} else if( obj.getType().equals("timestamp") ){ 
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
						HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td></tr>\n";
					} else if(obj.getType().equals("bool")){ 
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
						HTMLtext+="<td><select name=\""+obj.getName()+"\"><option> </option><option>S</option><option>N</option></select></td></tr>\n";
					} else { // float8,int4,numeric
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\"></td></tr>\n";
					}
				}
			}	
			HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
			Enumeration en = searchRelationVector.elements();
			SearchRelationBean sr = null;
			while (en.hasMoreElements()){
				sr = (SearchRelationBean)en.nextElement();
				HTMLtext+="\t<tr><td align=\"right\">"+sr.getDomain()+"</td><td colspan=\"2\"><textarea name=\""+sr.getInputName()+"\" cols=\"30\" rows=\"1\" wrap=\"physical\" readonly></textarea>";
				HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"window.open('searchpopup.jsp?searchname="+sr.getNameToSearch()+"&inputname="+sr.getInputName()+"',null,'height=400,width=600,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_cut.gif\" alt=\"filtro\" title=\"filtro\"></a>";
				//HTMLtext+="<a href=\"javascript:window.open('searchpopup.jsp?class="+sr.getNameToSearch()+"',null,'height=400,width=450,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_cut.gif\" alt=\"filtro\" title=\"filtro\"></a>";
				HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"javascript:document.searchForm."+sr.getInputName()+".value='';\"><img class=\"icon\" src=\"images/ico_cut_x.gif\" alt=\"rimuovi filtro\" title=\"rimuovi filtro\"></a></td></tr>\n";
			}
		} else {
			HTMLtext+="\t<tr><td colspan=\"3\">"+multilanguage.getMessage("com.warning")+"</td></tr>\n";
		}
		HTMLtext += "\t<tr>";
		HTMLtext += "<td colspan=\"3\"><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"method.value='back';submit();\">";
		if (user.isAllowed(thisname,1)){
			HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\"method.value='next';submit();\"></td>";	
		}
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage3(HttpServletRequest request){
		//Enumeration n = request.getParameterNames();
		Enumeration n =attributeVector1.elements();
		String className = request.getParameter("search");
		Vector filterVector = new Vector(); // contains WHERE conditions of the query
		String target = "";
		String value = "";
		String filterS = "";
		String f_value="";
		AttributeBean atbe = null;
		while (n.hasMoreElements()){
			atbe = (AttributeBean)n.nextElement();
			target = atbe.getName();
			value = request.getParameter(target);
			//System.out.println("SearchAction target="+target+" value="+value);
			if (value!=null && !value.trim().equals("") && !value.equals("&nbsp;")){
				value = value.toUpperCase();
				//System.out.println("u value="+value);
				filterS = "f_"+target;
				f_value = request.getParameter(filterS);
				//System.out.println("CardAction filter="+filter+" f_value="+f_value);
				if (f_value!=null && f_value.equals(multilanguage.getMessage("com.equal"))){
					filterS = "\""+target+"\"='"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals("=")){
						filterS = "\""+target+"\"='"+value+"'";
						filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals("<")){
					filterS = "\""+target+"\"<'"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(">")){
					filterS = "\""+target+"\">'"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.contains"))){
					filterS = "UPPER(\""+target+"\") LIKE '%"+value+"%'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.startswith"))){
					filterS = "UPPER(\""+target+"\") LIKE '"+value+"%'";
					filterVector.add(filterS);
				}
			}
		}
		Enumeration es = selectVector1.elements();
		String reportQuery = "";
		AttributeBean ab = null;
		while(es.hasMoreElements()){
			ab = (AttributeBean)es.nextElement();
			if (reportQuery.equals("")){
				reportQuery = "SELECT \""+ab.getName()+"\"";
			} else {
				reportQuery +=", \""+ab.getName()+"\"";
			}
		}
		reportQuery = reportQuery+" FROM \""+className+"\""; 
		// getting domain filters
		if (searchRelationVector==null){  // patch for back arrow in the browser
			// getting domains associated with this class / used only in filter mode
			Vector domainVector = null;
			Vector assetDomainVector = null;
			InheritsBean supBean = null;
			try {
				domainVector = MAP.selectDomainByClass(className);
				supBean = CMDB.selectSuperClass(className);
				if (!supBean.getParent().equals("class")){
					assetDomainVector = MAP.selectDomainByClass(supBean.getParent());
					assetDomainVector.addAll(domainVector);
					domainVector = assetDomainVector;
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			// creating vector of relations showed in the filter page
			Enumeration en3 = domainVector.elements();
			DomainBean dm = null;
			SearchRelationBean sr = null;
			searchRelationVector = new Vector();
			int i2 = 1;
			boolean addedThisLoop = false;
			while (en3.hasMoreElements()){
				dm = (DomainBean)en3.nextElement();
				addedThisLoop = false;
				if (dm.getStartClass().equals(className) || dm.getStartClass().equals(supBean.getParent())){
					sr = new SearchRelationBean(dm.getDirectDescription(),"dom"+i2,dm.getEndClass(),true);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
					addedThisLoop = true;
				} 
				if (dm.getEndClass().equals(className) || dm.getEndClass().equals(supBean.getParent())){
					if (addedThisLoop == true){
						i2++;
					}
					sr = new SearchRelationBean(dm.getInverseDescription(),"dom"+i2,dm.getStartClass(),false);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
				} 
				i2++;
			}
		}
		Enumeration ens = searchRelationVector.elements();
		String qds = "";
		String doms ="";
		SearchRelationBean srb = null;
		while (ens.hasMoreElements()){
			srb = (SearchRelationBean)ens.nextElement(); 
			target = srb.getInputName(); // dom1, dom2 etc..
			value = request.getParameter(target);
			if (value!=null & !value.equals("")){
				if (request.getSession().getAttribute(target)!=null){
					doms = (String)request.getSession().getAttribute(target);
					if (qds.equals("")){
						if (srb.isDirect()){
							//qds = " WHERE \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" "+doms+")";
							qds = " WHERE \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						} else {
							qds = " WHERE \"Id\" in (select \"IdObj2\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj1\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						}
					} else {
						if (srb.isDirect()){
							qds +=" AND \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						} else {
							qds +=" AND \"Id\" in (select \"IdObj2\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj1\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						}
					}
				}
			}
		}
		reportQuery+=qds;
		if (qds.equals("")){
			reportQuery += " WHERE \"Status\"='A'";
		} else {
			reportQuery += " AND \"Status\"='A'";
		}
		
		// adding where conditions
		Enumeration en = filterVector.elements();
		String sq = "";
		String sqq="";
		while (en.hasMoreElements()){
			sqq = (String)en.nextElement();
			sq+=" AND "+sqq;
		}
		reportQuery = reportQuery + sq;
		// creating query that contains only ids 
		// replacing select parameters with "Id"
		String sq2 = reportQuery.substring(reportQuery.indexOf("FROM"),reportQuery.length());
		String query = "SELECT \"Id\" "+sq2;
		// saved in the session, allow showing of subset of cards
		Hashtable filter = null;
		FilterBean fb = null;
		filter = new Hashtable();
		fb = new FilterBean();
		fb.setClassName(className);
		fb.setQuery(query);
		fb.setReportQuery(reportQuery);
		filter.put(className,fb);
		//System.out.println("query="+query+" reportQuery="+reportQuery);
		choice.put("page3",fb);
	}
	
	// page 4
	public void getPage4(HttpServletRequest request){
		HTMLclass presentation = new HTMLclass();
		resultsForPage = presentation.getResultsForPage();
		FilterBean fb = (FilterBean) choice.get("page3");
		int offset;
		if (request.getParameter("subpage")!=null){
			subpage = Integer.parseInt(request.getParameter("subpage"));
		}
		if (subpage==0 || subpage==1){
			//subpage=1;
			offset=0;
		} else {
			offset=(subpage-1)*presentation.getResultsForPage();
		}
		rowIdVector = null;
		/*
		if (CMDB==null){
			CMDB = new CMDBclass(db);
		}
		if (fb==null){
			System.out.println("fb is null");
		}
		*/
		try {
			rowIdVector = CMDB.selectCardsId(fb.getQuery());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			reportVector = CMDB.selectCards(fb.getReportQuery(),selectVector1,presentation.getResultsForPage(),offset);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//String query = fb.getReportQuery();
		// creating lookupVector if there are lookups
        System.out.println("reportVector.size()="+reportVector.size());
		totalPages = rowIdVector.size();
		if (reportVector!=null && reportVector.size()>totalPages){
			totalPages = reportVector.size();
		}
		if (subpage==0 && totalPages>0){
			subpage = 1;
		}
		if (rowIdVector==null){System.out.println("rowIdVector  nullo!");}
		/*
		lookupVector = new Vector();
		Vector options= null;
		AssetBean asb = null;
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (assetVector!=null){
			Enumeration enu = assetVector.elements();
			Hashtable hash = new Hashtable();
			while (enu.hasMoreElements()){
				asb = (AssetBean)enu.nextElement();
				if (asb.getType().equals("lookup")){
					try {
						if (!hash.containsKey(asb.getLookup())){ // don't get duplicates
							System.out.println("Getting lookup for "+asb.getLookup());
							options = LOOKUP.selectLookupByType(asb.getLookup());
							hash.put(asb.getLookup(),asb.getLookup());
						}
						//System.out.println("options.size="+options.size());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					if (options!=null){
						lookupVector.addAll(options);
					}
				}
			}
		}
		*/
	}
	public String toPage4(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 4</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		// creating lookup hash
		lookupHash = new Hashtable();
		LookupBean lb = null;
		if (lookupVector1!=null){
			Enumeration enume = lookupVector1.elements();
			while (enume.hasMoreElements()){
				lb = (LookupBean)enume.nextElement();
				if (!lookupHash.containsKey(lb.getId()+"")){
					lookupHash.put(lb.getId()+"",lb.getDescription());
				}
			}
		}
		Vector asvett = null;
		AssetBean as = null;
		if(reportVector==null){
			System.out.println("reportVector==null");
		}
    	if(reportVector!=null){
			int tot = totalPages/resultsForPage;
			System.out.println(totalPages+"/"+resultsForPage+"tot="+tot);
			if (totalPages%resultsForPage!=0){
				tot++;
			}
			int first,prev,next,last;
			first = 1;
			if (subpage>1){
				prev=subpage-1;
			} else {
				prev = 1;
			}
			if (subpage<tot){
				next=subpage+1;
			} else {
				next = tot;
			}
			last = tot;
			if (tot==0){
				subpage=0;
			}
 			//System.out.println("start"+start+"end"+end);
			HTMLtext+= "<table><tr><td colspan=\"5\">"+multilanguage.getMessage("HTMLclass.atpage")+" <input type=\"text\" size=\"3\" name=\"pagina\" maxlength=\"3\" value=\""+subpage+"\" onkeypress=\"goTo(event,"+first+","+last+")\"> di "+tot;
			HTMLtext+= "<a href=\"wizard.jsp?wizardpage=4&subpage="+first+"\"><img src=\"images/ico_first.gif\" alt=\"primo\" title=primo></a><a href=\"wizard.jsp?wizardpage=4&subpage="+prev+"\"><img src=\"images/ico_prev.gif\" alt=\"precedente\" title=precedente></a><a href=\"wizard.jsp?wizardpage=4&subpage="+next+"\"><img src=\"images/ico_next.gif\" alt=\"successivo\" title=successivo></a><a href=\"wizard.jsp?wizardpage=4&subpage="+last+"\"><img src=\"images/ico_last.gif\" alt=\"ultimo\" title=ultimo></a>";
			HTMLtext+= "</td></tr></table>\n";
 	    	HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
 			// creating header of the table
 			Enumeration en = selectVector1.elements();
 			AttributeBean ab = null;
 			// adding classDescription as first column
 			HTMLtext+="<th>Classe</th>";
 			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
					if (ab.getBaseDSP().equals("true")){
	 					HTMLtext+="<th>"+ab.getDescription()+"</th>";
					}
				}
 			}
 			// creating the table
 			String value="";
 			Enumeration enr = reportVector.elements();
 			int page=0;
 			if (subpage!=0){
 				page = (subpage-1)*resultsForPage;
 			}
 			while (enr.hasMoreElements()){
 				page++;
				asvett = (Vector)enr.nextElement();
 				Enumeration eni = asvett.elements();
 				as = (AssetBean)asvett.elementAt(0); // id
				HTMLtext+="<tr>";
 	 			// adding classDescription as first column
 	 			HTMLtext+="<td>"+as.getClassBean().getDescription()+"</td>";
 				while(eni.hasMoreElements()){
 					as = (AssetBean)eni.nextElement();
 					if (!as.getName().equals("Id") && !as.getName().equals("IdClass")){
 						if (as.getBaseDSP().equals("true")){
 							value = as.getValue();
 							if (value==null || value.equals("")){
 								value="&nbsp;";
 							} else if(as.getType().equals("lookup")){
 								value = (String)lookupHash.get(value);
 							}
							HTMLtext+="<td>"+value+"</td>";
 						}
 					}
 				}
 				HTMLtext+="</tr>\n";
			}	
 			HTMLtext+="</table>\n";
 			HTMLtext += "\t<table><tr>";
 			HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"method.value='back';submit();\">";
 			String thisname ="";
 			if (choice.get("startClass")!=null){
 				thisname = (String)choice.get("startClass");
 			}
 			if (reportVector.size()>0 && user.isAllowed(thisname,3)){
 	 			HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\"method.value='next';submit();\">";
 			}
 			HTMLtext += "</td>";
 			HTMLtext += "</tr></table>\n";
 		}
    	return HTMLtext;
	}
	public void actionPage4(HttpServletRequest request){
		if (rowIdVector==null){
			System.out.println("rowIdVector is null");
		}
		choice.put("page4",rowIdVector);
	}
	
	// page 5
	public void getPage5(HttpServletRequest request){
		// calculating classCollection
		classCollection = new LinkedList();
		Enumeration en = domainVector.elements();
		FilterBean fb = (FilterBean) choice.get("page3");
		String oldname = fb.getClassName();
		// creating a tree of old class       
        Hashtable pt = new Hashtable();  // key = child   value = parent
        Vector ptv = null;
		ptv = treeVector;
        en = ptv.elements();
        InheritsBean inh = null;
		while (en.hasMoreElements()){
			inh = (InheritsBean)en.nextElement();
			pt.put(inh.getChild(),inh.getParent());
		}
		HashSet ptset = new HashSet();
		String targ = oldname;
		while (pt.containsKey(targ)){
			ptset.add(targ);
			targ = (String)pt.get(targ);
		}
		// find if this is startClass or endClass
		direct = false;
		if (ptset.contains(currentDomain.getStartClass())){
			direct = true;
		}
		HashSet result = new HashSet();
		HashSet target = new HashSet();
		if (direct){ // then use endClass
			result.add(currentDomain.getEndClass());
			target.add(currentDomain.getEndClass());
		} else {
			result.add(currentDomain.getStartClass());
			target.add(currentDomain.getStartClass());
		}
		String tar = "";
		while (!target.isEmpty()){
			tar = (String)target.toArray()[0];
			en = treeVector.elements();
			while (en.hasMoreElements()){
				inh = (InheritsBean) en.nextElement();
				if (inh.getParent().equals(tar)){
					target.add(inh.getChild());
				}
			}
			result.add(tar);
			target.remove(tar);
		}
		ClassBean cb = null;
		Iterator it = result.iterator();
		while (it.hasNext()){
			tar = (String) it.next();
			cb = new ClassBean();
			cb.setName(tar);
			cb.setDescription((String)namedesc.get(tar));
			classCollection.add(cb);
		}
		String name = "";
		if (choice.containsKey("endClass")){
			name = (String)choice.get("endClass");
		} else {
			name = ((ClassBean) classCollection.toArray()[0]).getName();
		}
		// creating a tree of this class
		ptset = new HashSet();
		targ = name;
		while (pt.containsKey(targ)){
			ptset.add(targ);
			targ = (String)pt.get(targ);
		}
	    if (CMDB.getBean()==null){
	    	try {
				CMDB.setBean(CMDB.selectClassByName(name));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		System.out.println("classe="+name);
		// creating a select vector, contains elements to retrieve for the query select...
		try {
			attributeVector2 = CMDB.selectAllAttribute(name,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// creating selectVector
		Vector vec = new Vector();
		selectVector2 = new Vector();
		AttributeBean id = new AttributeBean();
		id.setName("Id");
		id.setSQLType("int4");
		id.setType("int4");
		vec.add(id);
		id = new AttributeBean();
		id.setName("IdClass");
		id.setSQLType("int4");
		id.setType("int4");
		vec.add(id);
		vec.addAll(selectVector2);
		selectVector2 = vec;
		Enumeration en2 = attributeVector2.elements();
		AttributeBean ab = null;
		while (en2.hasMoreElements()){
			ab = (AttributeBean)en2.nextElement();
			if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
				if (ab.getBaseDSP().equals("true")){
 					selectVector2.add(ab);
				}
			}
		}
		//CMDBlookup LOOKUP = new CMDBlookup(db);
		CMDBmap MAP = new CMDBmap(db);
        AttributeBean at = null;
		// creating lookupVector if there are lookups
		Enumeration enu = attributeVector2.elements();
		lookupVector2 = new Vector();
		Vector options= null;
		Hashtable hash = new Hashtable();
		while (enu.hasMoreElements()){
			at = (AttributeBean) enu.nextElement();
			if (at.getType().equals("lookup")){
				try {
					if (!hash.containsKey(at.getLookup())){ // don't get duplicates
						System.out.println("Getting lookup for "+at.getLookup());
						options = LOOKUP.selectLookupByType(at.getLookup());
						hash.put(at.getLookup(),at.getLookup());
					}
					//System.out.println("options.size="+options.size());
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if (options!=null){
					lookupVector2.addAll(options);
				}
			}
		}
		System.out.println("lookup.size="+lookupVector2.size());
		DomainBean dm = null;
		domainVector = new Vector();
		try {
			domainVector = MAP.selectAllDomain();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		// creating vector of relations showed in the filter page
		Enumeration en3 = domainVector.elements();
		SearchRelationBean sr = null;
		searchRelationVector = new Vector();
		int i2 = 1;
		boolean addedThisLoop = false;
		while (en3.hasMoreElements()){
			dm = (DomainBean)en3.nextElement();
			addedThisLoop = false;
			if (ptset.contains(dm.getStartClass())){
				sr = new SearchRelationBean(dm.getDirectDescription(),"dom"+i2,dm.getEndClass(),true);
				sr.setDomainRealName(dm.getName());
				searchRelationVector.add(sr);
				addedThisLoop = true;
			} 
			if (ptset.contains(dm.getEndClass())){
				if (addedThisLoop == true){
					i2++;
				}
				sr = new SearchRelationBean(dm.getInverseDescription(),"dom"+i2,dm.getStartClass(),false);
				sr.setDomainRealName(dm.getName());
				searchRelationVector.add(sr);
			} 
			i2++;
		}
	}
	public String toPage5(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 5</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr30\">classe</td>";
		HTMLtext+="<td><select name=\"f_className\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
		HTMLtext+="<td><select name=\"search\" onchange=\"method.value='search';submit()\">";
		Iterator it = classCollection.iterator();
		String thisname ="";
		if (choice.get("endClass")!=null){
			thisname = (String)choice.get("endClass");
		}
		while (it.hasNext()){
			ClassBean cb = (ClassBean)it.next();
			if (!thisname.equals(cb.getName())){
				HTMLtext+="<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";	
			} else {
				HTMLtext+="<option value=\""+cb.getName()+"\" selected>"+cb.getDescription()+"</option>";
			}
		}
		HTMLtext+="</select>";
		HTMLtext+="</td></tr>\n";
		if (user.isAllowed(thisname,1)){
			HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
			// showing only baseDSPs, removing the others
			AttributeBean toer = null;
			if (!showAll && attributeVector2!=null && attributeVector2.size()>0){
				for (int i=attributeVector2.size()-1;i>=0;i--){
					toer = (AttributeBean) attributeVector2.elementAt(i);
					if (!toer.getBaseDSP().equals("true")){
						attributeVector2.remove(i);
					}
				}
			}
			Enumeration e = attributeVector2.elements();
			AttributeBean obj = null;
			while (e.hasMoreElements()){
				obj = (AttributeBean)e.nextElement();
				if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
					//System.out.println(obj.getAName()+" in asset="+obj.getAType());
					if (obj.getType().equals("lookup")){
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
						HTMLtext+="<td><select name=\""+obj.getName()+"\">";
						// adding "" option
						HTMLtext+="<option></option>";
						Enumeration en = lookupVector2.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
							if (lb.getType().equals(obj.getLookup())){
								HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
							}
						}
						HTMLtext+="</select></td>";
						HTMLtext+="</tr>\n";
					} else if( obj.getType().equals("varchar") ){
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" onkeypress=\"doSearch(event)\"></td></tr>\n";
					} else if( obj.getType().equals("text") ){
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
						HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\" onkeypress=\"doSearch(event)\"></textarea></td></tr>\n";
					} else if( obj.getType().equals("date") ){ 
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
						HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td></tr>\n";
					} else if( obj.getType().equals("timestamp") ){ 
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
						HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\"></a></td></tr>\n";
					} else if(obj.getType().equals("bool")){ 
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
						HTMLtext+="<td><select name=\""+obj.getName()+"\"><option> </option><option>S</option><option>N</option></select></td></tr>\n";
					} else { // float8,int4,numeric
						HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
						HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\"></td></tr>\n";
					}
				}
			}	
			HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
			Enumeration en = searchRelationVector.elements();
			SearchRelationBean sr = null;
			while (en.hasMoreElements()){
				sr = (SearchRelationBean)en.nextElement();
				HTMLtext+="\t<tr><td align=\"right\">"+sr.getDomain()+"</td><td colspan=\"2\"><textarea name=\""+sr.getInputName()+"\" cols=\"30\" rows=\"1\" wrap=\"physical\" readonly></textarea>";
				HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"window.open('searchpopup.jsp?searchname="+sr.getNameToSearch()+"&inputname="+sr.getInputName()+"',null,'height=400,width=600,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_cut.gif\" alt=\"filtro\" title=\"filtro\"></a>";
				//HTMLtext+="<a href=\"javascript:window.open('searchpopup.jsp?class="+sr.getNameToSearch()+"',null,'height=400,width=450,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_cut.gif\" alt=\"filtro\" title=\"filtro\"></a>";
				HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"javascript:document.searchForm."+sr.getInputName()+".value='';\"><img class=\"icon\" src=\"images/ico_cut_x.gif\" alt=\"rimuovi filtro\" title=\"rimuovi filtro\"></a></td></tr>\n";
			}
		} else {
			HTMLtext+="\t<tr><td colspan=\"3\">"+multilanguage.getMessage("com.warning")+"</td></tr>\n";
		}
		HTMLtext += "\t<tr>";
		HTMLtext += "<td colspan=\"3\"><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"method.value='back';submit();\">";
		if (user.isAllowed(thisname,1)){
			HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\"method.value='next';submit();\"></td>";	
		}
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage5(HttpServletRequest request){
		//Enumeration n = request.getParameterNames();
		Enumeration n =attributeVector2.elements();
		String className = request.getParameter("search");
		Vector filterVector = new Vector(); // contains WHERE conditions of the query
		String target = "";
		String value = "";
		String filterS = "";
		String f_value="";
		AttributeBean atbe = null;
		while (n.hasMoreElements()){
			atbe = (AttributeBean)n.nextElement();
			target = atbe.getName();
			value = request.getParameter(target);
			//System.out.println("SearchAction target="+target+" value="+value);
			if (value!=null && !value.trim().equals("") && !value.equals("&nbsp;")){
				value = value.toUpperCase();
				//System.out.println("u value="+value);
				filterS = "f_"+target;
				f_value = request.getParameter(filterS);
				//System.out.println("CardAction filter="+filter+" f_value="+f_value);
				if (f_value!=null && f_value.equals(multilanguage.getMessage("com.equal"))){
					filterS = "\""+target+"\"='"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals("=")){
						filterS = "\""+target+"\"='"+value+"'";
						filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals("<")){
					filterS = "\""+target+"\"<'"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(">")){
					filterS = "\""+target+"\">'"+value+"'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.contains"))){
					filterS = "UPPER(\""+target+"\") LIKE '%"+value+"%'";
					filterVector.add(filterS);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.startswith"))){
					filterS = "UPPER(\""+target+"\") LIKE '"+value+"%'";
					filterVector.add(filterS);
				}
			}
		}
		Enumeration es = selectVector2.elements();
		String reportQuery = "";
		AttributeBean ab = null;
		while(es.hasMoreElements()){
			ab = (AttributeBean)es.nextElement();
			if (reportQuery.equals("")){
				reportQuery = "SELECT \""+ab.getName()+"\"";
			} else {
				reportQuery +=", \""+ab.getName()+"\"";
			}
		}
		reportQuery = reportQuery+" FROM \""+className+"\""; 
		// getting domain filters
		if (searchRelationVector==null){  // patch for back arrow in the browser
			// getting domains associated with this class / used only in filter mode
			Vector domainVector = null;
			Vector assetDomainVector = null;
			InheritsBean supBean = null;
			try {
				domainVector = MAP.selectDomainByClass(className);
				supBean = CMDB.selectSuperClass(className);
				if (!supBean.getParent().equals("class")){
					assetDomainVector = MAP.selectDomainByClass(supBean.getParent());
					assetDomainVector.addAll(domainVector);
					domainVector = assetDomainVector;
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			// creating vector of relations showed in the filter page
			Enumeration en3 = domainVector.elements();
			DomainBean dm = null;
			SearchRelationBean sr = null;
			searchRelationVector = new Vector();
			int i2 = 1;
			boolean addedThisLoop = false;
			while (en3.hasMoreElements()){
				dm = (DomainBean)en3.nextElement();
				addedThisLoop = false;
				if (dm.getStartClass().equals(className) || dm.getStartClass().equals(supBean.getParent())){
					sr = new SearchRelationBean(dm.getDirectDescription(),"dom"+i2,dm.getEndClass(),true);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
					addedThisLoop = true;
				} 
				if (dm.getEndClass().equals(className) || dm.getEndClass().equals(supBean.getParent())){
					if (addedThisLoop == true){
						i2++;
					}
					sr = new SearchRelationBean(dm.getInverseDescription(),"dom"+i2,dm.getStartClass(),false);
					sr.setDomainRealName(dm.getName());
					searchRelationVector.add(sr);
				} 
				i2++;
			}
		}
		Enumeration ens = searchRelationVector.elements();
		String qds = "";
		String doms ="";
		SearchRelationBean srb = null;
		while (ens.hasMoreElements()){
			srb = (SearchRelationBean)ens.nextElement(); 
			target = srb.getInputName(); // dom1, dom2 etc..
			value = request.getParameter(target);
			if (value!=null & !value.equals("")){
				if (request.getSession().getAttribute(target)!=null){
					doms = (String)request.getSession().getAttribute(target);
					if (qds.equals("")){
						if (srb.isDirect()){
							//qds = " WHERE \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" "+doms+")";
							qds = " WHERE \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						} else {
							qds = " WHERE \"Id\" in (select \"IdObj2\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj1\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						}
					} else {
						if (srb.isDirect()){
							qds +=" AND \"Id\" in (select \"IdObj1\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj2\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						} else {
							qds +=" AND \"Id\" in (select \"IdObj2\" from \""+srb.getNameToSearch()+"\",\""+srb.getDomainRealName()+"\" where \"IdObj1\"=\""+srb.getNameToSearch()+"\".\"Id\" AND \""+srb.getNameToSearch()+"\".\"Status\"='A' AND \""+srb.getDomainRealName()+"\".\"Status\"='A' "+doms+")";
						}
					}
				}
			}
		}
		reportQuery+=qds;
		//System.out.println("qds is ="+qds);
		if (qds.equals("")){
			reportQuery += " WHERE \"Status\"='A'";
		} else {
			reportQuery += " AND \"Status\"='A'";
		}
		
		// adding where conditions
		Enumeration en = filterVector.elements();
		String sq = "";
		String sqq="";
		while (en.hasMoreElements()){
			sqq = (String)en.nextElement();
			sq+=" AND "+sqq;
		}
		reportQuery = reportQuery + sq;
		// creating query that contains only ids 
		// replacing select parameters with "Id"
		String sq2 = reportQuery.substring(reportQuery.indexOf("FROM"),reportQuery.length());
		String query = "SELECT \"Id\" "+sq2;
		// saved in the session, allow showing of subset of cards
		Hashtable filter = null;
		FilterBean fb = null;
		filter = new Hashtable();
		fb = new FilterBean();
		fb.setClassName(className);
		fb.setQuery(query);
		fb.setReportQuery(reportQuery);
		filter.put(className,fb);
		request.getSession().setAttribute("filter",filter); 
		System.out.println("query="+query+" reportQuery="+reportQuery);
		choice.put("page5",fb);
	}
	
	// page 6
	public void getPage6(HttpServletRequest request){
		HTMLclass presentation = new HTMLclass();
		resultsForPage = presentation.getResultsForPage();
		FilterBean fb = (FilterBean) choice.get("page5");
		int offset;
		if (request.getParameter("subpage")!=null){
			subpage = Integer.parseInt(request.getParameter("subpage"));
		}
		if (subpage==0 || subpage==1){
			//subpage=1;
			offset=0;
		} else {
			offset=(subpage-1)*presentation.getResultsForPage();
		}
		rowIdVector = null;
		/*
		if (CMDB==null){
			CMDB = new CMDBclass(db);
		}
		if (fb==null){
			System.out.println("fb is null");
		}
		*/
		try {
			rowIdVector = CMDB.selectCardsId(fb.getQuery());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			reportVector = CMDB.selectCards(fb.getReportQuery(),selectVector2,presentation.getResultsForPage(),offset);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//String query = fb.getReportQuery();
		// creating lookupVector if there are lookups
        System.out.println("reportVector.size()="+reportVector.size());
		totalPages = rowIdVector.size();
		if (reportVector!=null && reportVector.size()>totalPages){
			totalPages = reportVector.size();
		}
		if (subpage==0 && totalPages>0){
			subpage = 1;
		}
		if (rowIdVector==null){System.out.println("rowIdVector  nullo!");}
		/*
		lookupVector = new Vector();
		Vector options= null;
		AssetBean asb = null;
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (assetVector!=null){
			Enumeration enu = assetVector.elements();
			Hashtable hash = new Hashtable();
			while (enu.hasMoreElements()){
				asb = (AssetBean)enu.nextElement();
				if (asb.getType().equals("lookup")){
					try {
						if (!hash.containsKey(asb.getLookup())){ // don't get duplicates
							System.out.println("Getting lookup for "+asb.getLookup());
							options = LOOKUP.selectLookupByType(asb.getLookup());
							hash.put(asb.getLookup(),asb.getLookup());
						}
						//System.out.println("options.size="+options.size());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					if (options!=null){
						lookupVector.addAll(options);
					}
				}
			}
		}
		*/
	}
	public String toPage6(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 6</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		// creating lookup hash
		//lookupHash = new Hashtable();
		LookupBean lb = null;
		if (lookupVector2!=null){
			Enumeration enume = lookupVector2.elements();
			while (enume.hasMoreElements()){
				lb = (LookupBean)enume.nextElement();
				if (!lookupHash.containsKey(lb.getId()+"")){
					lookupHash.put(lb.getId()+"",lb.getDescription());
				}
			}
		}
		Vector asvett = null;
		AssetBean as = null;
		if(reportVector==null){
			System.out.println("reportVector==null");
		}
    	if(reportVector!=null){
			int tot = totalPages/resultsForPage;
			System.out.println(totalPages+"/"+resultsForPage+"tot="+tot);
			if (totalPages%resultsForPage!=0){
				tot++;
			}
			int first,prev,next,last;
			first = 1;
			if (subpage>1){
				prev=subpage-1;
			} else {
				prev = 1;
			}
			if (subpage<tot){
				next=subpage+1;
			} else {
				next = tot;
			}
			last = tot;
			if (tot==0){
				subpage=0;
			}
 			//System.out.println("start"+start+"end"+end);
			HTMLtext+= "<table><tr><td colspan=\"5\">"+multilanguage.getMessage("HTMLclass.atpage")+" <input type=\"text\" size=\"3\" name=\"pagina\" maxlength=\"3\" value=\""+subpage+"\" onkeypress=\"goTo(event,"+first+","+last+")\"> di "+tot;
			HTMLtext+= "<a href=\"wizard.jsp?wizardpage=6&subpage="+first+"\"><img src=\"images/ico_first.gif\" alt=\"primo\" title=primo></a><a href=\"wizard.jsp?wizardpage=4&subpage="+prev+"\"><img src=\"images/ico_prev.gif\" alt=\"precedente\" title=precedente></a><a href=\"wizard.jsp?wizardpage=4&subpage="+next+"\"><img src=\"images/ico_next.gif\" alt=\"successivo\" title=successivo></a><a href=\"wizard.jsp?wizardpage=4&subpage="+last+"\"><img src=\"images/ico_last.gif\" alt=\"ultimo\" title=ultimo></a>";
			HTMLtext+= "</td></tr></table>\n";
 	    	HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
 			// creating header of the table
 			Enumeration en = selectVector2.elements();
 			AttributeBean ab = null;
 			// adding classDescription as first column
 			HTMLtext+="<th>Classe</th>";
 			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
					if (ab.getBaseDSP().equals("true")){
	 					HTMLtext+="<th>"+ab.getDescription()+"</th>";
					}
				}
 			}
 			HTMLtext+="<th>&nbsp;</th>";
 			// creating the table
 			String value="";
 			Enumeration enr = reportVector.elements();
 			int page=0;
 			if (subpage!=0){
 				page = (subpage-1)*resultsForPage;
 			}
 			while (enr.hasMoreElements()){
 				page++;
				asvett = (Vector)enr.nextElement();
 				Enumeration eni = asvett.elements();
 				as = (AssetBean)asvett.elementAt(0); // id
				HTMLtext+="<tr>";
 	 			// adding classDescription as first column
 	 			HTMLtext+="<td>"+as.getClassBean().getDescription()+"</td>";
 	 			int objid = Integer.parseInt(as.getValue());
 				while(eni.hasMoreElements()){
 					as = (AssetBean)eni.nextElement();
 					if (!as.getName().equals("Id") && !as.getName().equals("IdClass")){
 						if (as.getBaseDSP().equals("true")){
 							value = as.getValue();
 							if (value==null || value.equals("")){
 								value="&nbsp;";
 							} else if(as.getType().equals("lookup")){
 								value = (String)lookupHash.get(value);
 							}
							HTMLtext+="<td>"+value+"</td>";
 						}
 					}
 				}
 				HTMLtext+="<td><input type=\"radio\" name=\"target\" value=\""+as.getClassBean().getId()+"-"+objid+"\"></td>";
 				HTMLtext+="</tr>\n";
			}	
 			HTMLtext+="</table>\n";
 			HTMLtext += "\t<table><tr>";
 			HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"method.value='back';submit();\">";
 			String thisname ="";
 			if (choice.get("endClass")!=null){
 				thisname = (String)choice.get("endClass");
 			}
 			if (reportVector.size()>0 && user.isAllowed(thisname,3)){
 	 			HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.confirm")+"\" class=\"button\" onclick=\"method.value='next';submit();\">";
 			}
 			HTMLtext += "</td>";
 			HTMLtext += "</tr>\n</table>\n";
 		}
    	return HTMLtext;
	}
	public void actionPage6(HttpServletRequest request){
		if (rowIdVector==null){
			System.out.println("rowIdVector is null");
		}
		String target = request.getParameter("target");
		choice.put("page6",target);
		System.out.println("target="+target);
		Vector v1 = (Vector) choice.get("page4");
		System.out.println("v1="+v1.size());
		Vector v2 = new Vector();
		IdBean idb = new IdBean();
		String cids = target.substring(0,target.indexOf("-"));
		String ids = target.substring(target.indexOf("-")+1,target.length());
		int cid = Integer.parseInt(cids);
		int id = Integer.parseInt(ids);
		idb.setClassId(cid);
		idb.setId(id);
		v2.add(idb);
		try {
			MAP.modifyRelationBatch(currentDomain,direct,v1,v2,user.getUserName());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
} // end of class
