package cmdbuild.wizards.importutils;

import java.util.Hashtable;
import java.util.Vector;

import cmdbuild.collection.AssetBean;

public class ImportLine {
	
	private boolean toDelete; // refers to the entire line (in Red)
	private Vector headerVector;
	private Hashtable lookupHash;
	private Vector lineVector; // output
	private boolean importOk; // merges all the boolean values

	public ImportLine() {
		super();
		// TODO Auto-generated constructor stub
	}

	public ImportLine(Vector headerVector, Hashtable lookupHash, Vector temp) {
		super();
		// TODO Auto-generated constructor stub
		this.headerVector = headerVector;
		this.lookupHash = lookupHash;
		doMatch(temp);
	}

	private void doMatch(Vector temp){
		importOk = true;
		Vector result = new Vector();
		lineVector = new Vector();
		AssetBean as = null;
		AssetBean ash = null;
		// casting to headerVector.size
		result.addAll(temp);
		//System.out.println("temp.size="+temp.size()+" result.size="+result.size()+" header.size="+headerVector.size());
		if (temp.size()>headerVector.size()){
			// adding extra fields to the last field
			String val = "";
			for (int i=headerVector.size()-1;i<temp.size();i++){
				as = (AssetBean) temp.elementAt(i);
				val += as.getValue();
				//System.out.println("val="+val);
			}
			as = (AssetBean) result.elementAt(headerVector.size()-1);
			as.setValue(val);
			for (int i=result.size()-1;i>=headerVector.size();i--){
				result.removeElementAt(i);
				//System.out.println("removing an element at "+i);
			}
		}
		//System.out.println("result.size="+result.size());
		for (int i=0;i<headerVector.size();i++){
			ash = (AssetBean) headerVector.elementAt(i);
			as = new AssetBean();
			as.setName(ash.getName());
			as.setType(ash.getType());
			as.setLength(ash.getLength());
			as.setLookup(ash.getLookup());
			as.setMandatory(ash.getMandatory());
			if (i<result.size()){ // adding a field if there are too few fields
				as.setValue( ( (AssetBean)result.elementAt(i) ).getValue() );
			} else {  
				as.setValue("");
			}
			if (as.getType()==null){
				as.setToDelete(true);
				importOk = false;
			} else if (as.getType().equals("int4")){
				try {
					Integer.parseInt(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType().equals("float8")){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType().equals("numeric")){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType().equals("bool")){
				if (as.getValue()!=null && ( as.getValue().equals("true") || as.getValue().equals("false") ) ){
				} else {
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType().equals("varchar")){
				//System.out.println("varchar val="+as.getValue()+""+as.getLength()+"");
				if (as.getValue()!=null && as.getValue().length()>as.getLength()){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType().equals("lookup")){
				if (as.getValue()==null || !lookupHash.containsKey(as.getValue())){
					as.setToDelete(true);
					importOk = false;
				} 
			} else if (as.getType().equals("date") || as.getType().equals("timestamp")){
				try {
					java.sql.Date.valueOf(as.getValue());
				} catch (IllegalArgumentException e){
					//System.out.println("ImportLine="+as.getValue()+" date error:"+e);
					as.setToDelete(true);
					importOk = false;
				}
				if (as.getValue()!=null && !as.isToDelete()){
					//System.out.println(as.getValue().charAt(4)+" "+as.getValue().charAt(7));
					if (as.getValue().charAt(4)!='-' && as.getValue().charAt(7)!='-'){
						as.setToDelete(true);
						importOk = false;
					}
				}
			} // end varchar
			// saving this bean
			lineVector.add(as);
		}
		//System.out.println("linevector.size="+this.lineVector.size());
	}
	
	public void doCheck(){
		importOk = true;
		AssetBean as = null;
		for (int i=0;i<lineVector.size();i++){
			as = (AssetBean) lineVector.elementAt(i);
			if (as.getType()==null){
				as.setToDelete(true);
				// permit null value
				if (as.getMandatory().equals("Y")){
					importOk = false;	
				}
			} else if (as.getType().equals("int4")){
				try {
					Integer.parseInt(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType().equals("float8")){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType().equals("numeric")){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType().equals("bool")){
				if (as.getValue()!=null && !as.getValue().equals("") && ( as.getValue().equals("true") || as.getValue().equals("false") ) ){
				} else {
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType().equals("varchar")){
				//System.out.println("varchar val="+as.getValue()+""+as.getLength()+"");
				if (as.getValue()!=null && as.getValue().length()>as.getLength()){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType().equals("lookup")){
				if (as.getValue()==null || !lookupHash.containsKey(as.getValue())){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				} 
			} else if (as.getType().equals("date") || as.getType().equals("timestamp")){
				try {
					java.sql.Date.valueOf(as.getValue());
				} catch (IllegalArgumentException e){
					//System.out.println("ImportLine="+as.getValue()+" date error:"+e);
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
				if (as.getValue()!=null && !as.isToDelete()){
					System.out.println(as.getValue().charAt(4)+" "+as.getValue().charAt(7));
					if (as.getValue().charAt(4)!='-' && as.getValue().charAt(7)!='-'){
						as.setToDelete(true);
						if (as.getMandatory().equals("Y")){
							importOk = false;	
						}
					}
				}
			} // end varchar
			//System.out.println("as name="+as.getName()+" type="+as.getType()+" val="+as.getValue()+" ok?="+importOk+" toDelete?="+as.isToDelete());
		}	
	}	
	
	public Vector getLineVector() {
		return lineVector;
	}
	public void setLineVector(Vector lineVector) {
		this.lineVector = lineVector;
	}
	public Hashtable getLookupHash() {
		return lookupHash;
	}
	public void setLookupHash(Hashtable lookupHash) {
		this.lookupHash = lookupHash;
	}
	public boolean isToDelete() {
		return toDelete;
	}
	public void setToDelete(boolean toDelete) {
		this.toDelete = toDelete;
	}
	public Vector getHeaderVector() {
		return headerVector;
	}
	public void setHeaderVector(Vector headerVector) {
		this.headerVector = headerVector;
	}
	public boolean isImportOk() {
		return importOk;
	}
	public void setImportOk(boolean importOk) {
		this.importOk = importOk;
	}
	
} // end of class
